dnl    This file is part of the hk_classes libraries/packages
dnl    Copyright (C) 2001 Horst Knorr (hk_classes@knorrnet.de)

dnl    This file is free software; you can redistribute it and/or
dnl    modify it under the terms of the GNU Library General Public
dnl    License as published by the Free Software Foundation;
dnl    version 2 of the License.

dnl    This library is distributed in the hope that it will be useful,
dnl    but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl    Library General Public License for more details.

dnl    You should have received a copy of the GNU Library General Public License
dnl    along with this library; see the file COPYING.LIB.  If not, write to
dnl    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
dnl    Boston, MA 02111-1307, USA.


AC_DEFUN(HK_CLASSESINIT,
[
AC_MSG_CHECKING([HK_CLASSES INIT])
HK_CLASSESDIR=${HK_CLASSESDIR:-/usr/local/hk_classes}
HK_CLASSESINCDIR=$HK_CLASSESDIR/include
AC_SUBST(HK_CLASSESDIR)
AC_SUBST(HK_CLASSESINCDIR)
NODRIVER=true
POSSIBLE_DRIVERS="MYSQL"
AC_MSG_RESULT(OK)
])





AC_DEFUN(HK_MYSQLTEST,
[
AC_MSG_CHECKING([whether MYSQL is available])
if test "$MYSQLDIR" = ""; then
   MYSQLLIBDIR=/usr/lib/mysql
   MYSQLINCDIR=/usr/include/mysql
else MYSQLLIBDIR=$MYSQLDIR/lib/mysql
MYSQLINCDIR=$MYSQLDIR/include/mysql
fi
ac_save_LIBS="$LIBS"
ac_save_CPPFLAGS="$CPPFLAGS"
ac_save_CXXLIBS="$CXXLIBS"

CXXLIBS="$ac_save_CXXLIBS -L${MYSQLLIBDIR} -lmysqlclient"
LIBS="$ac_save_LIBS -L${MYSQLLIBDIR} -lmysqlclient"
CPPFLAGS="$ac_save_CPPFLAGS -I$MYSQLINCDIR"

AC_TRY_LINK([#include <mysql.h>],[;],[mysql_lib=yes],[mysql_lib=no])

AC_MSG_RESULT($mysql_lib)
if test $mysql_lib = yes ; then
NODRIVER=false
LIBS="$ac_save_LIBS"
CPPFLAGS="$ac_save_CPPFLAGS"
CXXLIBS="$ac_save_CXXLIBS"
DRIVERSDIR="$DRIVERSDIR hk_mysqlclasses"
AC_SUBST(MYSQLLIBDIR)
AC_SUBST(MYSQLINCDIR)
fi


])


AC_DEFUN(HK_DEFINEDRIVERS,
[
AC_SUBST(DRIVERSDIR)
AC_SUBST(NODRIVER)
AC_SUBST(POSSIBLE_DRIVERS)
])


AC_DEFUN(HK_CLASSESTEST,
[
AC_LANG_SAVE
AC_LANG_CPLUSPLUS

dnl AC_PREFIX_DEFAULT(${HK_CLASSESDIR:-/usr/local/hk_classes})
AC_CHECK_LIB(dl,dlopen)
AC_MSG_CHECKING([whether hk_classes are available])

ac_save_LIBS="$LIBS"
ac_save_CPPFLAGS="$CPPFLAGS"
ac_save_CXXLIBS="$CXXLIBS"
HK_CLASSESDIR=${HK_CLASSESDIR:-/usr/local/hk_classes}
HK_CLASSESINCDIR=$HK_CLASSESDIR/include

CXXLIBS="$ac_save_CXXLIBS -L${HK_CLASSESDIR} -lhk_classes"
LIBS="$ac_save_LIBS -L${HK_CLASSESDIR} -lhk_classes "
CPPFLAGS="$ac_save_CPPFLAGS -I$HK_CLASSESINCDIR"

AC_TRY_LINK([#include <hk_classes.h>],[  hk_drivermanager p_class;],[hk_lib=yes],[hk_lib=no])

AC_MSG_RESULT($hk_lib)
if test $hk_lib = no ; then
  AC_MSG_ERROR(
  hk_classes are NOT available !!

  ============================================================================

  If you have installed them in another directory than /usr/local/hk_classes
  set the environment variable HK_CLASSESDIR to your directory
  i.e.   HK_CLASSESDIR=/your/path/to/hk_classes

  ============================================================================

  )
fi

  AC_SUBST(HK_CLASSESDIR)
  AC_SUBST(HK_CLASSESINCDIR)
  AC_LANG_RESTORE


])
