// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.11 $
#include "hk_button.h"
#include "hk_form.h"
#include "hk_database.h"
#include "hk_datasource.h"

hk_button::hk_button(hk_form* form):hk_dsvisible(form)
{
#ifdef HK_DEBUG
hkdebug("hk_button::hk_button");
#endif
   p_visibletype=button;
   p_database=NULL;
   p_action=-1;
   p_showmaximized=false;
}

hk_button::~hk_button(void)
{

}

bool 	hk_button::push_action(void)
{
#ifdef HK_DEBUG
hkdebug("hk_button::push_action");
#endif
  if (p_form==NULL) return false;
  if (p_form->mode()==hk_presentation::design) return false;
  switch (action())
  {
   case 0 	: return widget_specific_open_form();
   case 1 	: return widget_specific_close_form();
   case 2 	: return widget_specific_open_table();
   case 3 	: return widget_specific_open_query();
   case 4 	: return widget_specific_preview_report();
   case 5 	: return widget_specific_print_report();


   case 6	: if (datasource()!=NULL)return datasource()->goto_first();else break;
   case 7	: if (datasource()!=NULL)return datasource()->goto_last();else break;
   case 8	: if (datasource()!=NULL)return datasource()->goto_next();else break;
   case 9	: if (datasource()!=NULL)return datasource()->goto_previous();else break;
   case 10	: if (datasource()!=NULL)
   				{
				  datasource()->setmode_insertrow();
				  return true;
				}
				  else break;
   case 11	: if (datasource()!=NULL)
   				{
				   datasource()->delete_actualrow();
				   return true;
				}
				  else break;
   case 12	: if (datasource()!=NULL)
   				{
				   datasource()->store_changed_data();
				   return true;
				}
				  else break;
   default	:;

  }

return false;

}

void hk_button::set_action(const hk_string& action,const hk_string& object,bool showmaximized, bool registerchange)
{
#ifdef HK_DEBUG
hkdebug("hk_button::set_action ",action);
hkdebug("object: ",object);
#endif
   long int a=-1;
   if (action=="open_form") a=0;
   else
   if (action=="close_form") a=1;
   else
   if (action=="open_table") a=2;
   else
   if (action=="open_query") a=3;
   else
   if (action=="preview_report") a=4;
   else
   if (action=="print_report") a=5;
   else
   if (action=="goto_firstrow") a=6;
   else
   if (action=="goto_lastrow") a=7;
   else
   if (action=="goto_nextrow") a=8;
   else
   if (action=="goto_previousrow") a=9;
   else
   if (action=="insert_row") a=10;
   else
   if (action=="delete_row") a=11;
   else
   if (action=="store_row") a=12;

   set_action(a,object,showmaximized,registerchange);

}

void hk_button::set_action(long action,const hk_string& object,bool showmaximized,bool registerchange)
{
   p_action=action;
   p_object=object;
   p_showmaximized=showmaximized;
   has_changed(registerchange);


}


bool hk_button::widget_specific_open_form(void)
{
 return false;
}

bool hk_button::widget_specific_close_form(void)
{
  return false;
}

bool 	hk_button::widget_specific_open_table(void)
{
  return false;
}

bool 	hk_button::widget_specific_open_query(void)
{
  return false;
}

bool 	hk_button::widget_specific_preview_report(void)
{
  return false;
}

bool 	hk_button::widget_specific_print_report(void)
{
  return false;
}


void  hk_button::savedata(ofstream& s )
{
#ifdef HK_DEBUG
hkdebug("hk_button::savedata");
#endif
       	hk_string dtag="HK_BUTTON";
	start_mastertag(s,dtag);
        set_tagvalue(s,"ACTION",p_action);
        set_tagvalue(s,"OBJECT",p_object);
        set_tagvalue(s,"SHOWMAXIMIZED",p_showmaximized);
	hk_dsvisible::savedata(s);
	end_mastertag(s,dtag);
}


void  hk_button::loaddata(const hk_string& definition)
{
#ifdef HK_DEBUG
hkdebug("hk_button::loaddata");
#endif

	get_tagvalue(definition,"ACTION",p_action);
	get_tagvalue(definition,"OBJECT",p_object);
	get_tagvalue(definition,"SHOWMAXIMIZED",p_showmaximized);
	hk_dsvisible::loaddata(definition);
	set_action(p_action,p_object,p_showmaximized,false);
}

hk_string hk_button::object(void)
{
   return p_object;
}

int hk_button::action(void)
{
  return p_action;
}


bool hk_button::show_maximized(void)
{
   return p_showmaximized;
}

void hk_button::set_database(hk_database* db)
{
  p_database=db;
}

hk_database* hk_button::database(void)
{
   return p_database;
}



