// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#ifndef HK_DEFINITIONS
#define HK_DEFINITIONS
#include <hk_string.h>
//#include <deque>
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>

#define  HK_DEBUG
#define HK_VERSION 043
/**
*@version $Revision: 1.9 $
*/
enum filetype{ft_query,ft_form,ft_report,ft_table,ft_index} ;

enum visibletype{editvisible,buttonvisible,gridvisible,boolvisible,unkownvisible};

enum enum_support{
supports_autoinc=1,
supports_boolfield=2,
supports_sql=4,
supports_transactions=8,
supports_referentialintegrity=16
}      ;

enum enum_need{
needs_host=1,
needs_username=2,
needs_password=4,
needs_sqldelimiter=8,
needs_port=16
};
/**
*struct_parsed_sql is needed for parsing th SQL-statement in hk_datasource
*/
typedef class
	{
	  public:
	  hk_string
	  select_part,
	  from_part,
	  where_part,
	  groupby_part,
	  having_part,
	  orderby_part ;
	} struct_parsed_sql;

/**
* used as entry to the raw data
*/

typedef class struct_raw_data
	{
	public:
	struct_raw_data(){length=0;data=NULL;}
	unsigned long 	length;
	const char*	data;

	} ;

typedef class struct_connectionfields
	{
	public:
	struct_connectionfields(){cancel=false;save=false;};
	hk_string host;
	hk_string user;
	hk_string password;
	hk_string sql_delimiter;
	hk_string port;
	bool cancel;
	bool save;
	} ;
int hk_random(int min,int max);
hk_string replace_all(const hk_string& what,const hk_string& where,const hk_string& with);





class hk_reportdata;

typedef hk_string  	recodefunctiontype(const hk_string&);
typedef hk_string	data_replacefunctiontype(hk_reportdata*,const hk_string&);
typedef unsigned long reportdatacounttype(hk_reportdata*);
typedef void	data_configurefunctiontype(hk_reportdata*);
/**
*See @ref section_replacefunctiontype
*/
enum alignmenttype{alignleft,alignright,aligncenter};

union number
{
 long integer;
 double real;
};

union longnumber
{
 long long integer;
 long double real;
};





#endif
