// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.8 $
#include "hk_dscombobox.h"
#include "hk_datasource.h"
#include "hk_presentation.h"
#include "hk_form.h"
#include "hk_dsdatavisible.h"
class hk_listvisible :public hk_dsdatavisible
{
 public:
 hk_listvisible(hk_dscombobox* combo,hk_form* form=NULL):hk_dsdatavisible(form)
 				   {
				     p_viewcolumn=NULL;
				     p_combo=combo;
				   }
 void set_viewcolumnname(hk_string n){
 					p_viewcolumnname=n;
					hk_datasource*d =datasource();
					if (d!=NULL) p_viewcolumn=d->column_by_name(n);
				     }

hk_string viewcolumnname(void){return p_viewcolumnname;}

hk_column* viewcolumn(void){return p_viewcolumn;}

virtual void set_datasource(hk_datasource* d)
					{
					  hk_dsdatavisible::set_datasource(d);
					  if (d==NULL) p_viewcolumn=NULL;
					}


virtual bool		before_columns_deleted(void)
					{
						hk_dsdatavisible::before_columns_deleted();
						p_viewcolumn=NULL;
						return true;
					}
virtual void 		before_source_vanishes(void)
					{
						hk_dsdatavisible::before_source_vanishes();
						p_viewcolumn=NULL;
                                        }
virtual bool datasource_enable(void)
				{

				    bool res=hk_dsdatavisible::datasource_enable();
				    p_viewcolumn=datasource()->column_by_name(p_viewcolumnname);
				    if (p_viewcolumn==NULL)p_viewcolumn=column();
        			    if (p_column==NULL)p_column=p_viewcolumn;
        			    if ((p_column==NULL)||(p_viewcolumn==NULL))return res;
				    if (p_combo!=NULL) p_combo->load_listitems();
				    return res;
				}
 private:

 hk_column* p_viewcolumn;
 hk_string p_viewcolumnname;
 hk_dscombobox* p_combo;

};




hk_dscombobox::hk_dscombobox(hk_form* form=NULL):hk_dsdatavisible(form)
{
#ifdef HK_DEBUG
//wanna_debug(true);
hkdebug("hk_dscombobox::hk_dscombobox");
#endif
	p_visibletype=combobox;
	p_listvisible= new hk_listvisible(this,form);
}

hk_dscombobox::~hk_dscombobox(void)
{
  delete p_listvisible;

}

void hk_dscombobox::set_listdatasource(hk_datasource* list)
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::set_listdatasource");
#endif
      if (list==datasource()&& datasource()!=NULL)
          {

	    show_warningmessage(hk_translate("Error: listdatasource and datasource in the combobox are identical!"));
	    return ;
	  }
	p_listvisible->set_datasource(list);
}

hk_datasource* hk_dscombobox::listdatasource(void)
{
 	return p_listvisible->datasource();

}

void hk_dscombobox::set_listcolumnname(const hk_string& listcolumn,bool registerchange)
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::set_listcolumnname");
#endif

p_listvisible->set_columnname(listcolumn);

has_changed(registerchange);
}


hk_string hk_dscombobox::listcolumnname(void)
{
	return p_listvisible->columnname();
}


void hk_dscombobox::set_viewcolumnname(const hk_string& viewcolumn,bool registerchange)
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::set_viewcolumnname");
#endif
  p_listvisible->set_viewcolumnname(viewcolumn);
  has_changed(registerchange);

}


hk_string hk_dscombobox::viewcolumnname(void)
{
  return p_listvisible->viewcolumnname();
}

void hk_dscombobox::savedata(ofstream& s )
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::savedata");
#endif
  hk_string tag="HK_COMBOBOX";
  start_mastertag(s,tag);
	hk_dsdatavisible::savedata(s);
	set_tagvalue(s,"VIEWCOLUMNNAME",p_listvisible->viewcolumnname());
 	set_tagvalue(s,"LISTCOLUMNNAME",p_listvisible->columnname());
	set_tagvalue(s,"LISTPRESENTATIONDATASOURCE",p_listvisible->presentationdatasource());
  end_mastertag(s,tag);
}

void hk_dscombobox::loaddata(const hk_string& definition)
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::loaddata");
#endif

     hk_string name;
     long int number;
     hk_dsdatavisible::loaddata(definition);
     if (get_tagvalue(definition,"VIEWCOLUMNNAME",name)) set_viewcolumnname(name);
     if (get_tagvalue(definition,"LISTCOLUMNNAME",name)) set_listcolumnname(name);
     if (get_tagvalue(definition,"LISTPRESENTATIONDATASOURCE",number)) set_listpresentationdatasource(number);


}


bool hk_dscombobox::set_listpresentationdatasource(long n, bool registerchange=true)
{
#ifdef HK_DEBUG
	hkdebug("hk_dscombobox::set_presentationdatasource");
#endif
  if (p_presentation==NULL)
  	{
		#ifdef HK_DEBUG
			hkdebug("hk_dscombobox::presentationdatasource presentation==NULL");
		#endif

		return false;
	 }
      if (n==presentationdatasource()&& presentationdatasource()!=-1)
          {

	    show_warningmessage(hk_translate("Error: listdatasource and datasource in the combobox are identical!"));
	    return false;
	  }
p_listvisible->set_presentationdatasource(n,false);
 has_changed(registerchange);

  return true;


}

long hk_dscombobox::listpresentationdatasource(void)
{
   return p_listvisible->presentationdatasource();
}



hk_column* hk_dscombobox::viewcolumn(void)
{
   return p_listvisible->viewcolumn();
}

hk_column* hk_dscombobox::listcolumn(void)
{
   return p_listvisible->column();
}

bool hk_dscombobox::datasource_enable(void)
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::datasource_enable");
#endif
  bool res=hk_dsdatavisible::datasource_enable();
  if (p_listvisible->datasource()!=NULL)p_listvisible->datasource()->enable();
  else  load_listitems();
  return res;
}

bool hk_dscombobox::datasource_disable(void)
{
   bool res=hk_dsdatavisible::datasource_disable();
  p_listvisible->datasource()->disable();
   return res;
}


bool hk_dscombobox::widget_specific_row_change(void)
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::widget_specific_row_change");
#endif
	hk_dsdatavisible::widget_specific_row_change();
	load_listitems();
	return true;
}


void hk_dscombobox::columndata_has_changed(void)
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::columndata_has_changed");
#endif
//	load_listitems();

}

void hk_dscombobox::after_store_changed_data(void)
{
#ifdef HK_DEBUG
hkdebug("hk_dscombobox::after_store_changed_data");
#endif

     load_listitems();
}



