// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.18 $
#include <hk_dsdatavisible.h>
#include <hk_form.h>
#include "hk_datasource.h"
#include "hk_presentation.h"
hk_dsdatavisible::hk_dsdatavisible(hk_presentation* p) :hk_dsvisible(p)
{
	p_column=NULL;
	p_columnname="";
	p_usedefault=false;
	#ifdef HK_DEBUG
	hkdebug("hk_dsdatavisible::creator");

	#endif
}


hk_dsdatavisible::~hk_dsdatavisible()
{
 #ifdef HK_DEBUG
 hkdebug("hk_dsdatavisible::destructor");
 #endif
 if (p_column!=NULL) p_column->datavisible_remove(this);
}


void hk_dsdatavisible::set_datasource(hk_datasource* d)
{
 #ifdef HK_DEBUG
 hkdebug("hk_dsdatavisible::set_datasource");
 #endif

   hk_dsvisible::set_datasource(d);
   if(d==NULL)
   {
    if (p_column!=NULL) p_column->datavisible_remove(this);
    p_column=NULL;
    return;
   }
   if ((d->is_enabled())&&(p_columnname!="")) column();
}

hk_datasource* hk_dsdatavisible::datasource(void)
{
 return hk_dsvisible::datasource();
}

void hk_dsdatavisible::set_columnname(const hk_string& c,bool registerchange)
{
 #ifdef HK_DEBUG
 hkdebug("hk_dsdatavisible::set_columnname(hk_string&)");
 hkclassname(c);
 debug_p_columnname=c;
 #endif
 	p_columnname=c;
	if (label().size()==0) set_label(c,registerchange);
 has_changed(registerchange);

   if (datasource()!=NULL)
   {
     if ((datasource()->is_enabled())&&(p_columnname!=""))
           {
		set_column();
		row_change();
     	    }
#ifdef HK_DEBUG
	else
	   {
	    // cout <<"columnname: "<<p_columnname<<endl<<"datasource-enabled() "<<(datasource()->is_enabled()?"ja":"nein")<<endl;
	   }
   }else
   {
 hkdebug("hk_dsdatavisible::column(hk_string&) datasource==NULL");
 #endif
   }
 	widget_specific_enable_disable();
	widget_specific_set_column();
}


hk_column* hk_dsdatavisible::column()
{
	#ifdef HK_DEBUG
	hkdebug("hk_dsdatavisible::column");
	hkdebug("columname= ",p_columnname.c_str());
	#endif
/*        if (datasource()!=NULL)
        	if (datasource()->depending_on()!=NULL) p_column=NULL;
*/ 	if (p_column!=NULL)
 	{
 	#ifdef HK_DEBUG
 	hkdebug("p_colum!=NULL=>return");
 	#endif
 	return p_column;
 	};
 	if (p_columnname!="")
 	{

 	if (p_datasource!=NULL)
 	{
 	#ifdef HK_DEBUG
 	hkdebug("p_colum=NULL");
 	#endif
 	  if (p_datasource->is_enabled())
 	     set_column();
//	     cout <<"p_column: "<<p_column<<endl;
 	 }
 	}
 	return p_column;
}

bool hk_dsdatavisible::datasource_disable(void)
{
	#ifdef HK_DEBUG
	hkdebug("hk_dsdatavisible::datasource_disable");
	#endif
	if (p_column!=NULL) p_column->datavisible_remove(this);
	p_column=NULL;
	hk_dsvisible::datasource_disable();
	//widget_specific_enable_disable();
 	return true;
}

bool hk_dsdatavisible::datasource_enable(void)
{
	#ifdef HK_DEBUG
	hkdebug("hk_dsdatavisible::datasource_enable");
	#endif

	if (p_column!=NULL) p_column->datavisible_remove(this);
	p_column=NULL;
        column();
	hk_dsvisible::datasource_enable();
        //widget_specific_enable_disable();
	return true;
}

void hk_dsdatavisible::datasource_delete(void)
{
  	#ifdef HK_DEBUG
	hkdebug("hk_dsdatavisible::datasource_delete");
	#endif

  if (p_column!=NULL) p_column->datavisible_remove(this);
  p_column=NULL;
  p_datasource=NULL;
  widget_specific_enable_disable();
}
bool hk_dsdatavisible::before_columns_deleted(void)
{
 if (p_column!=NULL) p_column->datavisible_remove(this);
 p_column=NULL;
 return true;
}

void hk_dsdatavisible::savedata(ofstream& s )
{
 hk_string tag="HK_DSDATAVISIBLE";
 start_mastertag(s,tag);
 hk_dsvisible::savedata(s);
 set_tagvalue(s,"COLUMN",p_columnname);
 set_tagvalue(s,"DEFAULTVALUE",p_defaultvalue);
 set_tagvalue(s,"USE_DEFAULTVALUE",p_usedefault);
 end_mastertag(s,tag);
}



void hk_dsdatavisible::loaddata(const hk_string& definition)
{
   hk_string buffer;
  get_tagvalue(definition,"HK_DSVISIBLE",buffer);

  hk_dsvisible::loaddata(buffer);
 get_tagvalue(definition,"COLUMN",p_columnname);
 hk_string b;
 if (get_tagvalue(definition,"DEFAULTVALUE",b))p_defaultvalue=b;
 bool bb;
 if (get_tagvalue(definition,"USE_DEFAULTVALUE",bb))p_usedefault=bb;

}

hk_string hk_dsdatavisible::columnname(void)
{
    return p_columnname;
}

void hk_dsdatavisible::widget_specific_set_column(void)
{

}

void hk_dsdatavisible::set_column(void)
{
     if (p_column!=NULL)
     	{
	   	p_column->datavisible_remove(this);
     		p_column=NULL;
        }
     if(datasource()!=NULL) p_column=datasource()->column_by_name(p_columnname);
     if (p_column!=NULL)
       {
          p_column->datavisible_add(this);
	  p_column->set_dateformat(dateformat());
	  p_column->set_timeformat(timeformat());
	  p_column->set_datetimeformat(datetimeformat());
	  if (!use_defaultvalue())
	  {
	    switch (p_column->fieldtype())
	    {
	      case hk_column::smallintegerfield : ;
	      case hk_column::integerfield : ; set_defaultvalue("0");break;
	      case hk_column::smallfloatingfield :;
	      case hk_column::floatingfield : ; set_defaultvalue("0.0");break;
	      case hk_column::datefield : ;
	      case hk_column::timefield :;
	      case hk_column::datetimefield  :; set_defaultvalue("%NOW%");break;
	      case hk_column::boolfield : ; set_defaultvalue("%FALSE%");break;

	    }

	  }
       }

}

bool 	hk_dsdatavisible::use_defaultvalue(void)
{
     if (p_column!=NULL)
     	if (p_column->fieldtype()==hk_column::auto_incfield)
     	   return true;
     return p_usedefault;
}

void 	hk_dsdatavisible::set_defaultvalue(const hk_string& def,bool registerchange)
{
  p_usedefault=true;
  p_defaultvalue=def;
 has_changed(registerchange);

}

hk_string  hk_dsdatavisible::raw_defaultvalue(void)
{

     return p_defaultvalue;
}

hk_string  hk_dsdatavisible::defaultvalue(void)
{

     if (p_column==NULL) return "";
     hk_string dt;

     switch  (p_column->fieldtype())
     {
       case hk_column::auto_incfield :  return hk_translate("[Auto]");
       case hk_column::datefield :  dt=p_date.date_asstring();break;
       case hk_column::timefield :  dt=p_date.time_asstring();break;
       case hk_column::datetimefield :;
       default:dt=p_date.datetime_asstring();
     }
     hk_string p_res=replace_all("%NOW%",p_defaultvalue,dt);
      p_res=replace_all("%NOWTIME%",p_res,p_date.time_asstring());
      p_res=replace_all("%NOWDATE%",p_res,p_date.date_asstring());
      p_res=replace_all("%TRUE%",p_res,p_column->bool_truevalue());
      p_res=replace_all("%FALSE%",p_res,p_column->bool_falsevalue());


     return p_res;
}

void 	hk_dsdatavisible::reset_default(bool registerchange)
{

  p_usedefault=false;
  p_defaultvalue="";
 has_changed(registerchange);
}


void hk_dsdatavisible::before_insert_row(void)
{
   if (datasource()==NULL||p_column==NULL||!p_usedefault) return;
   if (!p_column->has_changed())p_column->set_asstring(defaultvalue());

}

