// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.4 $
#include "hk_dsgridcolumn.h"
#include "hk_dsgrid.h"

hk_dsgridcolumn::hk_dsgridcolumn(void):hk_dsdatavisible()
{
#ifdef HK_DEBUG
//wanna_debug(true);
hkdebug("hk_dsgridcolumn::hk_dsgridcolumn");

#endif
   p_columnwidth=default_cellwidth;
   p_columntype=columnedit;
   p_grid=NULL;
}

void hk_dsgridcolumn::set_displayname(hk_string d,bool registerchange)
{
#ifdef HK_DEBUG
hkdebug("hk_dsgridcolumn::set_displayname");
#endif
  p_displayname=d;
     if (p_grid!=NULL) p_grid->has_changed(registerchange);


}

hk_string hk_dsgridcolumn::displayname(void)
{
   return p_displayname;
}

void hk_dsgridcolumn::set_columntype(hk_dsgridcolumn::enum_columntype t,bool registerchange)
{
#ifdef HK_DEBUG
hkdebug("hk_dsgridcolumn::set_columntype");
#endif
   p_columntype=t;
   if (p_grid!=NULL) p_grid->has_changed(registerchange);
}

hk_dsgridcolumn::enum_columntype hk_dsgridcolumn::columntype(void)
{

   return p_columntype;
}

void hk_dsgridcolumn::set_columnwidth(int w,bool registerchange)
{
#ifdef HK_DEBUG
hkdebug("hk_dsgridcolumn::set_columnwidth");
#endif
   p_columnwidth=w;
   if (p_grid!=NULL) p_grid->has_changed(registerchange);
}

int hk_dsgridcolumn::columnwidth(void)
{
   return p_columnwidth;

}
void hk_dsgridcolumn::savedata(ofstream& s)
{
#ifdef HK_DEBUG
hkdebug("hk_dsgridcolumn::savedata");
#endif
   hk_string ftag="HK_DSGRIDCOLUMN";
   start_mastertag(s,ftag);
   hk_dsdatavisible::savedata(s);
   set_tagvalue(s,"DISPLAYNAME",p_displayname);
   set_tagvalue(s,"COLUMNWIDTH",(long int)p_columnwidth);
   hk_string c;
   switch (p_columntype)
   {
   case columnbool : c="COLUMNBOOL";
   			break;

   default : c="COLUMNEDIT";
   }
   set_tagvalue(s,"COLUMNTYPE",c);

   end_mastertag(s,ftag);

}

void hk_dsgridcolumn::loaddata(const hk_string& definition)
{
#ifdef HK_DEBUG
hkdebug("hk_dsgridcolumn::loaddata");
#endif
   hk_dsdatavisible::loaddata(definition);
   get_tagvalue(definition,"DISPLAYNAME",p_displayname);
   get_tagvalue(definition,"COLUMNWIDTH",(long int)p_columnwidth);
   hk_string c;
   get_tagvalue(definition,"COLUMNTYPE",c);
   if (c=="COLUMNBOOL")p_columntype=columnbool;
   else p_columntype=columnedit;
   set_columnwidth(p_columnwidth,false);
   set_displayname(p_displayname,false);
   set_columntype(p_columntype,false);
}

void hk_dsgridcolumn::set_grid(hk_dsgrid* g)
{
#ifdef HK_DEBUG
hkdebug("hk_dsgridcolumn::set_grid");
#endif
  p_grid=g;
  if (g!=NULL) set_datasource(g->datasource());
}





