// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#ifndef HK_DSGRIDCOLUMN_H
#define HK_DSGRIDCOLUMN_H
#include "hk_dsdatavisible.h"
class hk_column;
class hk_dsgrid;
const int default_cellwidth=60;
const int default_cellheight=20;

/**
*@short  structure of a column in a grid
*@version $Revision: 1.3 $
*@author Horst Knorr (hk_classes@knorrnet.de)
*
*structure of a column in a grid.
*/
class  hk_dsgridcolumn :public hk_dsdatavisible
{
friend class hk_dsgrid;
	   public:
enum  enum_columntype{columnedit,columnbool};
	  hk_dsgridcolumn(void);
/**
*the text displayed in the column header. If not set the columnname will be displayed
*/
	  void  set_displayname(hk_string,bool registerchange=true);
	  hk_string displayname(void);
/**
*if columntype is columnedit the celldata will be shown as a string
*if columntype is columnbool the celldata will be shown as a boolean field
*/
	  void set_columntype(enum_columntype,bool registerchange=true);
	  enum_columntype columntype(void);
/**
*the (visible) width of the column
*/
	  void set_columnwidth(int ,bool registerchange=true);
	  int columnwidth(void);
virtual   void  savedata(ofstream& s);
virtual   void loaddata(const hk_string& definition);

	  private:
	  void set_grid(hk_dsgrid*);
	  hk_string	p_displayname;
	  enum_columntype 	p_columntype;
	  int		p_columnwidth;
	  hk_dsgrid* p_grid;

};



#endif
