// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.24 $
#include "hk_form.h"
#include "hk_visible.h"
#include "hk_dsdatavisible.h"
#include "hk_dsgrid.h"
#include "hk_database.h"
#include <fstream.h>
#include <hk_dsvisible.h>
#include <hk_dsdatavisible.h>
#include "hk_dslineedit.h"
#include "hk_dsrowselector.h"
#include "hk_dsboolean.h"
#include "hk_dscombobox.h"
#include "hk_dsmemo.h"
#include "hk_button.h"
#include "hk_label.h"
#ifdef HAVE_CONFIG_H
#include "config.h"
#else
#define VERSION UNKNOWN
#endif

const unsigned int teiler=10000;

hk_form::hk_form(void) : hk_presentation()
{
#ifdef HK_DEBUG
hkdebug("hk_form::hk_form");
#endif
  p_visibletype=hk_visible::form;
  set_formdesignsize(800,600);
  p_presentationtype=hk_presentation::form;
  p_vupn=0;
}


hk_form::~hk_form(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::~hk_form");
#endif
clear_visiblelist();
#ifdef HK_DEBUG
hkdebug("hk_form::~hk_form ENDE");
#endif
}


void hk_form::add_visible(hk_visible* v)
{
#ifdef HK_DEBUG
hkdebug("hk_form::add_visible");
#endif
  if (v==NULL) return;
  v->p_vupn=p_vupn;
  p_vupn++;
  p_visibles.insert(p_visibles.end(),v);

}

void hk_form::remove_visible(hk_visible* v)
{
#ifdef HK_DEBUG
hkdebug("hk_form::remove_visible");
#endif
   p_visibles.remove(v);
}



hk_dsgrid*	hk_form::new_grid(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::new_grid");
#endif
   if (mode()==view)return NULL;
   hk_dsgrid* g = widget_specific_new_grid();
   if (g!=NULL)
   	{
		add_visible(g);
		set_has_changed();
		g->set_presentationdatasource(presentationdatasource());
	}
   return g;
}

hk_dsrowselector*	hk_form::new_rowselector(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::new_rowselector");
#endif
   if (mode()==view)return NULL;
   hk_dsrowselector* g = widget_specific_new_rowselector();
   if (g!=NULL)
   	{
		add_visible(g);
		set_has_changed();
		g->set_presentationdatasource(presentationdatasource());
	}
   return g;
}

hk_dslineedit* 	hk_form::new_lineedit(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::new_lineedit");
#endif
   if (mode()==view)return NULL;
   hk_dslineedit* g = widget_specific_new_lineedit();
   if (g!=NULL)
   	{
		add_visible(g);
		set_has_changed();
		g->set_presentationdatasource(presentationdatasource());
	}
   return g;
}

hk_dscombobox* 	hk_form::new_combobox(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::new_lineedit");
#endif
   if (mode()==view)return NULL;
   hk_dscombobox* g = widget_specific_new_combobox();
   if (g!=NULL)
   	{
		add_visible(g);
		set_has_changed();
		g->set_presentationdatasource(presentationdatasource());
	}
   return g;
}

hk_dsboolean*	hk_form::new_bool(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::new_bool");
#endif
   if (mode()==view)return NULL;
   hk_dsboolean* g = widget_specific_new_bool();
   if (g!=NULL)
   	{
		add_visible(g);
		set_has_changed();
		g->set_presentationdatasource(presentationdatasource());
	}
   return g;

}

hk_dsmemo*	hk_form::new_memo(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::new_memo");
#endif
   if (mode()==view)return NULL;
   hk_dsmemo* g = widget_specific_new_memo();
   if (g!=NULL)
   	{
		add_visible(g);
		set_has_changed();
		g->set_presentationdatasource(presentationdatasource());
	}
   return g;

}

hk_button* 	hk_form::new_button(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::new_button");
#endif
   if (mode()==view)return NULL;
   hk_button* g = widget_specific_new_button();
   if (g!=NULL)
   	{
		add_visible(g);
		set_has_changed();
	}
   return g;

}

hk_label* 	hk_form::new_label(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::new_label");
#endif
   if (mode()==view)return NULL;
   hk_label* g = widget_specific_new_label();
   if (g!=NULL)
   	{
		add_visible(g);
		set_has_changed();
	}
   return g;

}


void		hk_form::set_formsize(unsigned int w, unsigned int h)
{
#ifdef HK_DEBUG
hkdebug("hk_form::set_formsize");
#endif
 p_actualwidth= (w>0?w:1);
 p_actualheight=(h>0?h:1);
 widget_specific_formresize();
 list<hk_visible*>::iterator it=p_visibles.begin();
// set_has_changed();
 while (it!=p_visibles.end())
 {
  (*it)->widget_specific_form_resizes();
  it++;
 }

}
void		hk_form::set_formdesignsize(unsigned int w, unsigned int h,bool registerchange)
{
#ifdef HK_DEBUG
hkdebug("hk_form::set_formdesignsize");
#endif
 p_designwidth=w;
 p_designheight=h;
 set_formsize(w,h);
 if (registerchange) set_has_changed();
}

unsigned int	hk_form::horizontal2relativ(unsigned int h,bool dynamic)
{
#ifdef HK_DEBUG
hkdebug("hk_form::horizontal2relativ");
#endif
  return (h*teiler) / (dynamic?p_actualwidth:p_designwidth);

}

unsigned int	hk_form::vertical2relativ(unsigned int v,bool dynamic)
{
#ifdef HK_DEBUG
hkdebug("hk_form::vertical2relativ");
#endif
  return (v*teiler) / (dynamic?p_actualheight:p_designheight);

}
unsigned int	hk_form::relativ2horizontal(unsigned int r,bool dynamic)
{
#ifdef HK_DEBUG
hkdebug("hk_form::relativ2horizontal");
#endif
  return (r*(dynamic?p_actualwidth:p_designwidth) )/teiler;

}
unsigned int	hk_form::relativ2vertical(unsigned int r,bool dynamic)
{
#ifdef HK_DEBUG
hkdebug("hk_form::relativ2vertical");
#endif
  return (r*(dynamic?p_actualheight:p_designheight))/teiler;

}

void		hk_form::widget_specific_fieldresize(hk_visible* v)
{

}


bool  hk_form::save_form(const hk_string& n,bool ask)
{
#ifdef HK_DEBUG
hkdebug("hk_form::save_form");
#endif
  if (database()==NULL)
  {
   show_warningmessage(hk_translate("Form error: No database defined!"));
   return false;

  }
  if (n.size()>0) set_name(n);

  reset_has_changed();
  if (name().size()==0) if (!ask_name())return false;
 ofstream* p_save=database()->savestream(name(),ft_form,ask);
 if (p_save==NULL) return false;
 savedata(*p_save);
 delete p_save;
 reset_has_changed();
  return true;
}

void hk_form::load_form(const hk_string& n)
{
#ifdef HK_DEBUG
hkdebug("hk_form::load_form");
#endif
  if (database()==NULL)
  {
   show_warningmessage(hk_translate("Form error: No database defined!"));
   return ;

  }
  if (has_changed())
    {
       save_form();
       reset_has_changed();
    }
  if (n.size()>0) set_name(n);
  enum_mode modebuffer=mode();
  p_mode=design;
  if (name().size()==0) if (!ask_name())return ;
  hk_string res =database()->load(name(),ft_form);
  loaddata(res);
  p_mode=modebuffer;
  widget_specific_after_loadform();
       reset_has_changed();

#ifdef HK_DEBUG
hkdebug("hk_form::load_form ENDE");
#endif

}

void 	hk_form::savedata(ofstream& s)
{
#ifdef HK_DEBUG
hkdebug("hk_form::savedata");
#endif
   hk_string ftag="FORM";
   hk_string vistag="FORMOBJECT";
   start_mastertag(s,ftag);
   set_tagvalue(s,"HK_FORMVERSION",(hk_string)VERSION);
   hk_string datatag="FORMDATA";
   start_mastertag(s,datatag);
   hk_dsvisible::savedata(s);
   set_tagvalue(s,"FORMDESIGNWIDTH",(long unsigned int)p_designwidth);
   set_tagvalue(s,"FORDESIGNHEIGHT",(long unsigned int)p_designheight);
   end_mastertag(s,datatag);
   hk_presentation::savedata(s);

   list<hk_visible*>::iterator it=p_visibles.begin();
   while (it!=p_visibles.end())
   {
     start_mastertag(s,vistag);
     (*it)->savedata(s);
     end_mastertag(s,vistag);
     it++;
   }

   end_mastertag(s,ftag);
}

void 	hk_form::loaddata(const hk_string& definition)
{
#ifdef HK_DEBUG
hkdebug("hk_form::loaddata");
#endif
   clear_visiblelist();
   get_tagvalue(definition,"FORMDESIGNWIDTH",(long unsigned int) p_designwidth);
   get_tagvalue(definition,"FORDESIGNHEIGHT",(long unsigned int)p_designheight);
   set_formdesignsize(p_designwidth,p_designheight,false);
	hk_string g;
	get_tagvalue(definition,"PRESENTATION",g);
	hk_presentation::loaddata(g);
	get_tagvalue(definition,"FORMDATA",g);
	hk_dsvisible::loaddata(g);
	hk_string buffer;
	hk_string buffer2;
	hk_string value;
	int i=1;
	while (get_tagvalue(definition,"FORMOBJECT",value,i))
        {
          get_tagvalue(value,"VISIBLETYPE",buffer2);
	  hk_visible* vis=NULL;
//   		if (buffer2=="TEXTLABEL") vis=new ;
//  		else
  		if (buffer2=="BUTTON") vis=new_button();
  		else
  		if (buffer2=="SELECTOR") vis=new_rowselector();
  		else
  		if (buffer2=="BOOLEAN") vis=new_bool();
  		else
  		if (buffer2=="LINEEDIT") vis=new_lineedit();
  		else
  		if (buffer2=="MEMO") vis=new_memo();
  		else
  		if (buffer2=="COMBOBOX") vis=new_combobox();
  		else
  		if (buffer2=="GRID") vis=new_grid();
  		else
  		if (buffer2=="TEXTLABEL") vis=new_label();

  		if (vis!=NULL)
	  	{
			vis->loaddata(value);
			if (vis->p_vupn==-1)
			  {
			   vis->p_vupn=p_vupn;
			   p_vupn++;
			  }
			else
			if (vis->p_vupn>=p_vupn) p_vupn=vis->p_vupn+1;
	  	}
	  i++;
        }
}



void hk_form::clear_visiblelist(void)
{
#ifdef HK_DEBUG
hkdebug("hk_form::clear_visiblelist()");
#endif
   list<hk_visible*>::iterator it=p_visibles.begin();
   while (it!=p_visibles.end())
   {
    hk_visible* v=(*it);
    it++;
    v->p_form =NULL;
    v->p_presentation = NULL;
    delete v;
   }
#ifdef HK_DEBUG
hkdebug("hk_form::clear_visiblelist() ENDE");
#endif

}

hk_visible*	hk_form::get_visible(long nr)
{
#ifdef HK_DEBUG
hkdebug("hk_form::get_visible(long)");
#endif
   list<hk_visible*>::iterator it=p_visibles.begin();
   while (it!=p_visibles.end())
   {
     if ( (*it)->p_vupn==nr) return (*it);
     it++;
   }
   return NULL;
}

