// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.6 $
#include "hk_importcsv.h"
#include "hk_database.h"
#include "hk_column.h"
#include "hk_datasource.h"
hk_importcsv::hk_importcsv(void):hk_dsvisible()
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::constructor");
#endif
 p_textdelimiter="";
 p_rowdelimiter="\n";
 p_betweenfields=",";
 p_filestream=NULL;
 p_firstrow_contains_fieldnames=true;
 p_create_new_table=true;
 p_datamode=true;
// wanna_debug(true);
}



hk_importcsv::~hk_importcsv(void)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::destructor");
#endif
 if (p_filestream!=NULL)delete p_filestream;
 p_filestream = NULL;
}



bool hk_importcsv::execute(void)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::execute");
#endif
   p_datamode=true;
   if ((p_textdelimiter.size()==0)&&(p_betweenfields.size()==0)
        ||p_filename.size()==0)
     {
      reset();
      return false;
     }

   if (!initialize_table())
   {
      reset();

    return false;
   }
  hk_string sbuffer;
  int i=1;
   set_columns();
#ifdef HK_DEBUG
hkdebug("hk_importcsv::execute while");
#endif

  while (!p_filestream->eof())
  {
         getline(*p_filestream,sbuffer);
     create_valuelist(sbuffer);
     unsigned int z=p_columnlist.size();
     if (z>datasource()->columns()->size())z=datasource()->columns()->size();
     datasource()->setmode_insertrow();
     //*************************************
     //*          store data               *
     //*************************************
  vector<colstruct>::iterator col_it=p_columnlist.begin();
  vector<hk_string>::iterator value_it=p_valuelist.begin();
    if ((p_valuelist.size()>0)&&(p_columnlist.size()))
    {
     for (unsigned int k=0;k<z;k++)
     {
      if ((*col_it).col!=NULL)
      {
       (*col_it).col->set_asstring((*value_it));
       col_it++;
       value_it++;
      }
    }
     }

     i++;
     datasource()->store_changed_data();
  }
#ifdef HK_DEBUG
hkdebug("hk_importcsv::execute while ENDE");
#endif
      reset();



return true;
}

bool hk_importcsv::initialize_table(void)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::initialize_table");
#endif
hk_string sbuffer;
   if (datasource()==NULL)
      {
         show_warningmessage(hk_translate("No datasource defined!"));
         return false;
      }


   if (p_filestream!=NULL) delete p_filestream;
   p_filestream=new ifstream(p_filename.c_str(),ios::in);
   if (!(*p_filestream))
     {hk_string w=hk_translate("No such CSV file: ");
       w+=p_filename;
       show_warningmessage(w);
      reset();

       return false;
     }

     if (p_firstrow_contains_fieldnames)
       {
         getline(*p_filestream,sbuffer); //erste zeile lesen
     	 if (p_columnlist.size()==0)
     	   {
		create_valuelist(sbuffer);
     	 	create_automatic_columns();
     	   }
       }
      if (p_create_new_table)
      {
        if (datasource()->database()->table_exists(datasource()->name()))
        datasource()->database()->delete_table(datasource()->name());
        datasource()->setmode_createtable();
        hk_column* col=NULL;
        getline(*p_filestream,sbuffer); //erste Datenzeile einlesen
	p_datamode=false;
	create_valuelist(sbuffer);
	p_datamode=true;
        int zaehler=0;
        char buf[70];
        hk_string newfieldname;
#ifdef HK_DEBUG
hkdebug("hk_importcsv::initialize_table vor while");
#endif

	vector<colstruct>::iterator colit=p_columnlist.begin();
        vector<hk_string>::iterator it=p_valuelist.begin();
	while (it!=p_valuelist.end())
        {
	 #ifdef HK_DEBUG
	  hkdebug("in while beginn");
	 #endif
         col=datasource()->new_column();
	 sprintf(buf,"%d",zaehler);
         if (p_firstrow_contains_fieldnames)
	 {
	 col->set_name((*colit).colname);
	 }
	 else
         {
           newfieldname="namenlos_";newfieldname+=buf;
           col->set_name(newfieldname);
           add_columnname(newfieldname);
         }
	 #ifdef HK_DEBUG
	hkdebug("angelegte Spalte: ",col->name());
	#endif

	 int c=interpret_fieldtype((*it));
	 switch (c)
         {
           case 1:col->set_fieldtype(hk_column::floatingfield);
           		break;
           case 2:col->set_fieldtype(hk_column::integerfield);
           		break;
           default:col->set_fieldtype(hk_column::textfield);
         }
         if ((*it).size()>255)col->set_fieldtype(hk_column::memofield);
         else col->set_size(255);
	 #ifdef HK_DEBUG
	hkdebug("initialize_table ++");
	#endif

         zaehler++;
         it++;
//         if (colit!=p_columnlist.end())
	colit++;
	} //end while
#ifdef HK_DEBUG
hkdebug("hk_importcsv::initialize_table NACH while");
//datasource()->wanna_debug(true);
#endif

        if(! datasource()->create_table_now())
        {
	#ifdef HK_DEBUG
	hkdebug("Tabelle kann nicht angelegt werden");
	#endif
          reset();
          return false;
        }

      } //end create table
#ifdef HK_DEBUG
hkdebug("hk_importcsv::initialize_table nach create table");
#endif

  if (!datasource()->is_enabled())datasource()->enable();
  if (!datasource()->is_enabled())
      	{
         reset();

	 show_warningmessage(hk_translate("Datasource could not be enabled"));
       	 return false;
       	}

#ifdef HK_DEBUG
hkdebug("hk_importcsv::initialize_table nach enable");
#endif

// Datei wieder auf erste Datenzeile stellen
   if (p_filestream!=NULL) delete p_filestream;
   p_filestream=new ifstream(p_filename.c_str(),ios::in);
   if (p_firstrow_contains_fieldnames)
      getline(*p_filestream,sbuffer); //erste zeile lesen
#ifdef HK_DEBUG
hkdebug("hk_importcsv::initialize_table vor return");
#endif


 return true;
}




void	hk_importcsv::set_filedefinition(const hk_string& fielddelimiter,const hk_string& betweenfields, const hk_string& rowdelimiter)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::set_filedefinition");
#endif
   p_textdelimiter=fielddelimiter;
   p_betweenfields=betweenfields;
   p_rowdelimiter=rowdelimiter;
}


void hk_importcsv::set_filename(const hk_string& filename)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::set_filename");
#endif
p_filename=filename;

}



void hk_importcsv::set_firstrow_contains_fieldnames(bool f)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::set_firstrow_contains_fieldnames");
#endif
  p_firstrow_contains_fieldnames=f;
}


void hk_importcsv::create_valuelist( hk_string& row)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::create_valuelist");
#endif
   size_t returnkey = row.find('\r');
   if (returnkey<=row.size())  row.replace(returnkey,1,"");

 p_valuelist.erase(p_valuelist.begin(),p_valuelist.end());
    if(row.size()<=p_textdelimiter.size()*2+p_betweenfields.size())
    {
	#ifdef HK_DEBUG
	hkdebug("hk_importcsv::create_valuelist return am Beginn der whileschleife");
	#endif
       return;
    }
  unsigned long offset=0;
  unsigned long beginposition=0;
  unsigned long endposition=0;
  hk_string field;
#ifdef HK_DEBUG
hkdebug("Zeile: ",row);
hkdebug("Gesamtlnge: ",(int)row.size());
hkdebug("Zeile: ",row);
hkdebug("Zeile: 12345678901234567890123456789012345678901234567890123456789012345678901234567890");

#endif
     while (offset<=row.size())
     {
       if (p_betweenfields.size()>0)endposition=row.find(p_betweenfields,offset);
       if (endposition>row.size())endposition=row.size();
       field.assign(row,beginposition,endposition-beginposition);


      if(p_textdelimiter.size()>0 && p_datamode)
      {
       int b=field.find(p_textdelimiter,0)+p_textdelimiter.size();
       int e=field.find(p_textdelimiter,b);
       if (e>row.size())e=row.size();
      hk_string n; n.assign(field,b,e-b);
      field=n;
      }


       p_valuelist.insert(p_valuelist.end(),field);//cout <<"erkanntes Feld eingefgt: " <<field<<endl;
//cout<<"Gesamtlnge "<<row.size()<<" Feld: "<<field <<"   Begin: "<<beginposition<<" End: "<<endposition<<" Offset: "<<offset<<endl;
       beginposition=endposition+p_betweenfields.size();
       offset=endposition+p_textdelimiter.size()+p_betweenfields.size();

     if ( offset>(unsigned)row.size()||
     	  beginposition>(unsigned)row.size()||
     	  endposition>(unsigned)row.size()     )
	  {
	   return;
	  }
     }
// cout <<"nach While Ausgang Offset < rowsize Offset= "<<offset<<" rowsize "<<row.size()<<endl;
}

void	hk_importcsv::add_columnname(const hk_string& col)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::add_columnname");
#endif
    colstruct p_col;
    p_col.colname=replace_all(" ",col,"_");
    p_col.col=NULL;
    p_columnlist.insert(p_columnlist.end(),p_col);
}


void hk_importcsv::clear_columnlist(void)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::clear_columnlist");
#endif
  p_columnlist.erase(p_columnlist.begin(),p_columnlist.end());
}

void hk_importcsv::set_columns(void)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::set_columns");
#endif
  if (datasource()==NULL) return;
  vector<colstruct>::iterator it=p_columnlist.begin();
  while (it!=p_columnlist.end())
  {
   (*it).col=datasource()->column_by_name((*it).colname);
   it++;
  }

}
void	hk_importcsv::create_automatic_columns(void)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::create_automatic_columns");
#endif
 clear_columnlist();
 vector<hk_string>::iterator it=p_valuelist.begin();
 while(it!=p_valuelist.end())
 {
  add_columnname((*it));
  it++;
 }


}

bool hk_importcsv::before_columns_deleted(void)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::before_columns_deleted");
#endif
  vector<colstruct>::iterator it=p_columnlist.begin();
  while (it!=p_columnlist.end())
  {
   (*it).col=NULL;
   it++;
  }
//  clear_columnlist();
 return true;
}


int hk_importcsv::interpret_fieldtype(hk_string& field)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::interpret_fieldtype");
#endif
  int num=0;
  int komma=0;
  int alpha=0;
  for (unsigned int i=0;i<field.size();i++)
  {

    if (isdigit(field[i])) num++;
    else if (field[i]=='.')komma++;
         else alpha++;

  }
//  cout <<"interpretiere feldtyp: "<<field<<endl;
//  cout <<"alpha: "<<alpha<<" komma: "<<komma<<" num: "<<num<<endl;
 if (alpha>0||komma>1)return 0;
 if (num>0) if (komma==1) return 1;
 			else return 2;
 return 0;

}


void hk_importcsv::reset(void)
{
#ifdef HK_DEBUG
hkdebug("hk_importcsv::reset");
#endif
 delete p_filestream;
 p_filestream=NULL;
 clear_columnlist();
}
