// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.8 $
#include "hk_reportdata.h"
#include "hk_reportsection.h"
#include "hk_report.h"
#include <math.h>
#include "hk_reportutils.h"
#include "hk_column.h"
#include "hk_datasource.h"

//********************************************
//**   hk_reportdata                        **
//********************************************

hk_reportdata::hk_reportdata(hk_report* e, hk_reportsection* s):hk_dsdatavisible(e)
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata constructor");
#endif
  p_report=e;
  p_section=s;
  p_count=0;
   p_runningcount=false;
   p_minmax_alreadyset=false;
   p_fillchars=0;
   p_replacefunction=NULL;
   p_align=alignleft;
   p_datacountfunction=NULL;
   p_dataconfigurefunction=NULL;
   p_top=p_bottom=p_left=p_right=p_luro=p_loru=false;
   p_wordbreak=false;
   set_height(40);
   set_width(300);
//  wanna_debug(true);

}
hk_reportdata::~hk_reportdata()
{
}



hk_string hk_reportdata::replace(const hk_string& where)
{
  hk_string p_localbuffer;
#ifdef HK_DEBUG
hkdebug("hk_reportdata::replace");
#endif
//cout <<"hk_reportdata::replace"<<endl;
// p_localbuffer=hk_reportbase::replace(where);
 p_localbuffer=where;
// replace column variables like #column1# with value
// cout <<"p_report "<<p_report<<" datasource "<<p_report->datasource()<<" col "<<p_report->datasource()->columns()<<endl;
 list<hk_column*>* cols=p_report->datasource()->columns();

 list<hk_column*>::iterator it=cols->begin();
 while(it!=cols->end())
 {
  hk_string name="#";
  name+=(*it)->name();
  name+="#";
  if (p_report->recodefunction()==NULL)
       p_localbuffer=replace_all(name,p_localbuffer,(*it)->asstring());
  else     p_localbuffer=replace_all(name,p_localbuffer,p_report->recodefunction()((*it)->asstring()));
  it++;
 }
      char* m= new char[50];
      sprintf(m,"%d",x());
      p_localbuffer=replace_all("%XPOS%",p_localbuffer,m);
      sprintf(m,"%d",y());
      p_localbuffer=replace_all("%YPOS%",p_localbuffer,m);
      sprintf(m,"%d",width());
      p_localbuffer=replace_all("%WIDTH%",p_localbuffer,m);
      sprintf(m,"%d",height());
      p_localbuffer=replace_all("%HEIGHT%",p_localbuffer,m);
      sprintf(m,"%ld",p_report->pagenumber());
      p_localbuffer=replace_all("%PAGENUMBER%",p_localbuffer,m);
      sprintf(m,"%ld",p_report->absolutepagenumber());
      p_localbuffer=replace_all("%ABSOLUTEPAGENUMBER%",p_localbuffer,m);
      sprintf(m,"%ld",p_report->rownumber());
      p_localbuffer=replace_all("%ROWNUMBER%",p_localbuffer,m);

      sprintf(m,"%ld",p_count);
      hk_string align;
      switch (p_align)
      {
      case alignright : align="RIGHT";break;
      case aligncenter : align="CENTER";break;
      default	      : align="LEFT";
      };

      p_localbuffer=replace_all("%ALIGN%",p_localbuffer,align);
//      cout <<"datasource: "<<datasource()<<" p_column: "<<column()<<" columnname: "<<columnname()<<endl;

if (column()!=NULL)
   {
      p_localbuffer=replace_all("%value%",p_localbuffer,column()->asstring());
      p_localbuffer=replace_all("%fieldname%",p_localbuffer,columnname());
      p_localbuffer=replace_all("%displayname%",p_localbuffer,p_displayname);
      p_localbuffer=replace_all("%COUNT%",p_localbuffer,m);
      hk_string format="%.3f";
      if (column()->fieldtype()==hk_column::integerfield||column()->fieldtype()==hk_column::auto_incfield)
         {
    	    sprintf(m,"%ld",sum.integer);
            p_localbuffer=replace_all("%SUM%",p_localbuffer,m);
    	    sprintf(m,"%ld",min.integer);
            p_localbuffer=replace_all("%MIN%",p_localbuffer,m);
    	    sprintf(m,"%ld",max.integer);
            p_localbuffer=replace_all("%MAX%",p_localbuffer,m);
            if (p_count>0)
            {
             double average=(double)sum.integer/(double)p_count;
	     sprintf(m,format.c_str(),average);
             p_localbuffer=replace_all("%AVERAGE%",p_localbuffer,m);

          double stddev=sqrt((squaresum.integer-2*average*sum.integer+p_count*average*average)/p_count);
	     sprintf(m,format.c_str(),stddev);
             p_localbuffer=replace_all("%STDDEV%",p_localbuffer,m);

             stddev=sqrt((squaresum.integer-2*average*sum.integer+p_count*average*average)/(p_count-1));
	     sprintf(m,format.c_str(),stddev);
             p_localbuffer=replace_all("%STDDEVSAMPLE%",p_localbuffer,m);
           }

      if (column()->fieldtype()==hk_column::floatingfield)
         {
    	    sprintf(m,format.c_str(),sum.real);
            p_localbuffer=replace_all("%SUM%",p_localbuffer,m);
    	    sprintf(m,format.c_str(),min.real);
            p_localbuffer=replace_all("%MIN%",p_localbuffer,m);
    	    sprintf(m,format.c_str(),max.real);
            p_localbuffer=replace_all("%MAX%",p_localbuffer,m);

                        if (p_count>0)
            {
             double average=sum.real/(double)p_count;

    	    if (p_count>0) sprintf(m,format.c_str(),average);
            p_localbuffer=replace_all("%AVERAGE%",p_localbuffer,m);

          double stddev=sqrt((squaresum.real-2*average*sum.real+p_count*average*average)/p_count);
	     sprintf(m,format.c_str(),stddev);
             p_localbuffer=replace_all("%STDDEV%",p_localbuffer,m);

             stddev=sqrt((squaresum.real-2*average*sum.real+p_count*average*average)/(p_count-1));
	     sprintf(m,format.c_str(),stddev);
             p_localbuffer=replace_all("%STDDEVSAMPLE%",p_localbuffer,m);
           }
           strcpy(m,"?");
      	   p_localbuffer=replace_all("%AVERAGE%",p_localbuffer,m);
       	   p_localbuffer=replace_all("%STDDEV%",p_localbuffer,m);
       	   p_localbuffer=replace_all("%STDDEVSAMPLE%",p_localbuffer,m);
            }

         }


      delete[] m;
      if (p_report!=NULL)
        {
          recodefunctiontype* r=p_report->recodefunction();
	      hk_string value;
	      hk_string name;
	      hk_string display;
          if (r==NULL)
           {
	      value=column()->asstring();
	      name=columnname();
	      display=p_displayname;
           }
           else
	   {
	      value=r(column()->asstring());
	      name=r(columnname());
	      display=r(p_displayname);
            }
//      cout <<"replace_all(\"%VALUE%\","<<p_localbuffer<<","<<value<<endl;
      p_localbuffer=replace_all("%VALUE%",p_localbuffer,value);
//       cout<< "ergibt: "<<p_localbuffer<<")"<<endl;
//      cout <<"replace_all(\"%FIELDNAME%\","<<p_localbuffer<<","<<name<<endl;
      p_localbuffer=replace_all("%FIELDNAME%",p_localbuffer,name);
//       cout<< "ergibt: "<<p_localbuffer<<")"<<endl;
      p_localbuffer=replace_all("%DISPLAYNAME%",p_localbuffer,display);
     p_localbuffer=replace_all("%FONT%",p_localbuffer,font());
      p_localbuffer=replace_all("%FONTSIZE%",p_localbuffer,fontsize());

        }

   }
//cout <<"ende"<<endl;
return p_localbuffer;

}





hk_string hk_reportdata::actual_hk_string(void)
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata::actual_hk_string");
#endif
  hk_string r;
  hk_string b;
  r=p_beforedata+p_data+p_afterdata;
  r=replace(r);
  b=r;
  if (p_replacefunction!=NULL) r=p_replacefunction(this,r);
 if (p_datacountfunction!=NULL)set_counts_as(p_datacountfunction(this));
 p_report->rowcount(counts_as());
 r=b;
 return  r;

}


void hk_reportdata::count(void)
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata::count");
#endif
   p_count++;
   if(column()!=0)
     if (column()->fieldtype()==hk_column::integerfield
   			||column()->fieldtype()==hk_column::auto_incfield)

   {
        hk_string s=column()->asstring();
   	int r=atoi(s.c_str());
   	sum.integer+=r;
   	squaresum.integer+=r*r;
   	     if (s.size()>0)
   	    {
   	      if (p_minmax_alreadyset)
   	      {
   	        if (r<min.integer)min.integer=r;
   	        if (r>max.integer)max.integer=r;
   	      }
   	      else
   	      {
   	        min.integer=r;
   	        max.integer=r;
   	        p_minmax_alreadyset=true;
   	      }
   	    }

   }
   else if(column()->fieldtype()==hk_column::floatingfield)
  {
        hk_string s=column()->asstring();
   	double r=strtod(s.c_str(),NULL);
   	sum.real+=r;
   	squaresum.real+=r*r;
   	     if (s.size()>0)
   	    {
   	      if (p_minmax_alreadyset)
   	      {
   	        if (r<min.real)min.real=r;
   	        if (r>max.real)max.real=r;
   	      }
   	      else
   	      {
   	        min.real=r;
   	        max.real=r;
   	        p_minmax_alreadyset=true;
   	      }
   	    }
   }
}


void hk_reportdata::reset_count()
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata::reset_count");
#endif
   if (!p_runningcount)
     {
        p_count=0;
        if (column()!=NULL)
          if (column()->fieldtype()==hk_column::integerfield||column()->fieldtype()==hk_column::auto_incfield)
            {
              sum.integer=0;
              squaresum.integer=0;
              min.integer=0;
              max.integer=0;
              p_minmax_alreadyset=false;
            }
          else
          if (column()->fieldtype()==hk_column::floatingfield)
            {
              sum.real=0;
              squaresum.real=0;
              min.real=0;
              max.real=0;
              p_minmax_alreadyset=false;
            }
     }
}




hk_string hk_reportdata::font(void)
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata::font");
#endif
 if (p_font.size()==0) return p_section->font();
 	else return p_font;
}

hk_string hk_reportdata::fontsize(void)
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata::fontsize");
#endif
  if (p_fontsize.size()==0) return p_section->fontsize();
   return p_fontsize;
}


void	hk_reportdata::set_topline(bool l=true)
{
    p_top=l;
   if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);
}
void	hk_reportdata::set_bottomline(bool l=true)
{
    p_bottom=l;
    if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);

}
void	hk_reportdata::set_leftline(bool l=true)
{
    p_left=l;
    if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);

}
void	hk_reportdata::set_rightline(bool l=true)
{
    p_right=l;
    if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);

}

void	hk_reportdata::set_diagonalluro(bool l=true)
{
   p_luro=l;
    if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);
}

void	hk_reportdata::set_diagonalloru(bool l=true)
{
  p_loru=l;
  if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);
}


void	hk_reportdata::set_frame(bool l=true)
{
    p_top=l;
    p_bottom=l;
    p_left=l;
    p_right=l;
    if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);
}


void hk_reportdata::set_wordbreak(bool b)
{
 p_wordbreak=b;
    if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);
}

void  hk_reportdata::savedata(ofstream& s)
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata::savedata");
#endif
 s<<"<DATA>";
 hk_dsdatavisible::savedata(s);
 set_tagvalue(s,"DATAVALUE",p_data);
 set_tagvalue(s,"BEFOREDATA",p_beforedata);
 set_tagvalue(s,"AFTERDATA",p_afterdata);
 set_tagvalue(s,"DISPLAYNAME",p_displayname);
 set_tagvalue(s,"X",(long)x());
 set_tagvalue(s,"Y",(long)y());
 set_tagvalue(s,"WIDTH",(long)width());
 set_tagvalue(s,"HEIGHT",(long)height());
 set_tagvalue(s,"TOPBORDER",p_top);
 set_tagvalue(s,"LEFTBORDER",p_left);
 set_tagvalue(s,"RIGHTBORDER",p_right);
 set_tagvalue(s,"BOTTOMBORDER",p_bottom);
 set_tagvalue(s,"DIAGONALLORU",p_loru);
 set_tagvalue(s,"DIAGONALLURO",p_luro);
 set_tagvalue(s,"WORDBREAK",p_wordbreak);
 hk_string align;
 switch (p_align)
 {
 case alignright:align="RIGHT";
 		  break;
 case aligncenter:align="CENTER";
 		  break;
 default	:align="LEFT";
 }
 set_tagvalue(s,"ALIGN",align);
hk_string configurefunc="NONE";
 if (p_dataconfigurefunction==configure_postscriptdata) configurefunc="POSTSCRIPT";
set_tagvalue(s,"DATACONFIGUREFUNCTION",configurefunc);


 s<<"</DATA>"<<endl;

}

void  hk_reportdata::loaddata(const hk_string& definition)
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata::loaddata");
#endif
 hk_dsdatavisible::loaddata(definition);
 get_tagvalue(definition,"DATAVALUE",p_data);
 get_tagvalue(definition,"BEFOREDATA",p_beforedata);
 get_tagvalue(definition,"AFTERDATA",p_afterdata);
 get_tagvalue(definition,"DISPLAYNAME",p_displayname);
 long res;
 get_tagvalue(definition,"X",res);set_x(res);
 get_tagvalue(definition,"Y",res);set_y(res);
 get_tagvalue(definition,"WIDTH",res);set_width(res);
 get_tagvalue(definition,"HEIGHT",res);set_height(res);
 get_tagvalue(definition,"TOPBORDER",p_top);
 get_tagvalue(definition,"LEFTBORDER",p_left);
 get_tagvalue(definition,"RIGHTBORDER",p_right);
 get_tagvalue(definition,"BOTTOMBORDER",p_bottom);
 get_tagvalue(definition,"DIAGONALLORU",p_loru);
 get_tagvalue(definition,"DIAGONALLURO",p_luro);
 get_tagvalue(definition,"WORDBREAK",p_wordbreak);
 hk_string align;
 get_tagvalue(definition,"ALIGN",align);
 if (align=="RIGHT") p_align=alignright;
 else if (align=="CENTER")p_align=aligncenter;
 hk_string configurefunc;
 get_tagvalue(definition,"DATACONFIGUREFUNCTION",configurefunc);
 if  (configurefunc=="POSTSCRIPT") p_dataconfigurefunction=&configure_postscriptdata;
 if(p_dataconfigurefunction!=NULL)p_dataconfigurefunction(this);

}
void	hk_reportdata::set_configurefunction(data_configurefunctiontype* f)
{
#ifdef HK_DEBUG
hkdebug("hk_reportdata::set_configurefunction");
#endif
   p_dataconfigurefunction=f;
   if (p_dataconfigurefunction!=NULL) p_dataconfigurefunction(this);
}	

