// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#ifndef HK_REPORTPOSTSCRIPT
#define HK_REPORTPOSTSCRIPT
#include "hk_report.h"
#include "hk_reportsection.h"
#include "hk_reportutils.h"
enum pageformattype {A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,letter,legal,executive,tabloid,userdefined} ;
enum orientationtype{landscape,portrait};
/**
*
*@short  the reportclass to print reports
*@version $Revision: 1.3 $
*@author Horst Knorr (hk_classes@knorrnet.de)

*hk_reportpostscript allows you to get Postscript output. Postscript (copyrighted by Adobe)
*is basic printing format under Linux.You can create reports with different fonts, align text
*left, centered or right, position the data whereever you want on the page.
*
*All size values(i.e.pagesize, bordersize,positions etc) are defined in 1/10 of a millimeter (zmm= Zehntel Millimeter).
*So 1 cm is 100 zmm.
*/



class hk_reportpostscript:public hk_report
{
	public:
	hk_reportpostscript(void);
virtual	~hk_reportpostscript(void);
     hk_reportsection* new_section(void);
void set_pageformat(pageformattype t=A4);
void set_pageformat(int width , int height);
void set_orientation(orientationtype o=portrait);
void set_borders(int left=200, int right=200, int top=200, int bottom=300);

/**
* returns in 1/10mm
*/		
int 	formatwidth(pageformattype t=A4);
int 	formatheight(pageformattype t=A4);
void	set_topline(bool l=true);
void	set_bottomline(bool l=true);
void	set_leftline(bool l=true);
void	set_rightline(bool l=true);
void	set_diagonalluro(bool l=true);
void	set_diagonalloru(bool l=true);
void	set_frame(bool l=true);
	
	protected:
void	configure_page(void); 	
 	private:
int	from_ps(int p);
int 	to_ps(int p);
	int p_pagewidth;
	int p_pageheight;
	int p_borderleft;
	int p_borderright;
	int p_bordertop;
	int p_borderbottom;
	pageformattype p_pageformat;
	orientationtype p_orientation;
	hk_string p_filehead;
	hk_string p_defaultbeforedata;
	hk_string p_defaultafterdata;
bool p_top;
bool p_left;
bool p_right;
bool p_bottom;
bool p_loru;
bool p_luro;	
	
};	


#endif 
