// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.6 $
#include "hk_reportsection.h"
#include "hk_report.h"
#include "hk_reportdata.h"
#include <list>
#include "hk_reportutils.h"
#include "hk_database.h"
#include "hk_column.h"
#include "hk_datasource.h"

//********************************************
//** hk_reportsection                       **
//********************************************


hk_reportsection::hk_reportsection(hk_report* e):hk_dsdatavisible(e)
{
   p_report=e;
   p_unique=false;
   p_automatic_create_datas=true;
   p_already_automaticcreated_data=false;
   p_uniqueendsection=false;
   p_default_columnvalue="%VALUE%";
   p_newpageaftersection=false;
   p_sectionwasprinted=false;
   p_subreport=NULL;
   p_replacefunction=NULL;
   p_sectioncountfunction=NULL;
   p_default_dataconfigurefunction=NULL;
   p_subreportdatasource=NULL;
   p_automatic_created_datasource=false;
//  wanna_debug(true);

}



hk_reportsection::~hk_reportsection()
{
  vector<hk_reportdata*>::iterator it=p_data.begin();
  while(it!=p_data.end())
    {
      delete (*it);
      it++;
    }

}



hk_reportdata* hk_reportsection::new_data(void)
{
  hk_reportdata* d=new hk_reportdata(p_report,this);
  d->set_data(p_default_columnvalue);
  d->set_beforedata(p_default_beforecolumnvalue);
  d->set_afterdata(p_default_aftercolumnvalue);
  if (p_default_dataconfigurefunction)
  {
    d->set_configurefunction(p_default_dataconfigurefunction);
    p_default_dataconfigurefunction(d);
  }
//  int s=atoi(d->fontsize());

//  d->height(s);
  p_data.insert(p_data.end(),d);
  d->set_presentationdatasource(presentationdatasource());
  return d;

}


bool hk_reportsection::new_uniquevalue(void)
{
  bool result=false;
 if (p_report->datasource()->max_rows()==0)return true;

 //now check endsection
  if (p_unique&&p_uniqueendsection)
  {
   if (p_uniquecolumnname.size()==0)
     {
        if (p_report->datasource()->row_position()==p_report->datasource()->max_rows()-1)return true;
        else return false;
     }
   else
     {
       if (column()==NULL&&
           p_report->datasource()->row_position()==p_report->datasource()->max_rows()-1)return true;
        else
           {
     		result=(p_lastuniquevalue!=column()->asstring_at(p_report->datasource()->row_position()+1));
     		p_lastuniquevalue=column()->asstring_at(p_report->datasource()->row_position()+1);
     		if (p_report->datasource()->row_position()==0
     		    &&p_report->datasource()->max_rows()>1)return false;
     		if ( p_report->datasource()->row_position()>=p_report->datasource()->max_rows()-1)return true;
                 return result;

           }

     }

  }

 //now check beginning sections
 if (column()!=NULL)
    {
     result=(p_lastuniquevalue==column()->asstring());
     p_lastuniquevalue=column()->asstring();


    }
 else if (p_report->datasource()!=NULL)
         if (p_report->datasource()->row_position()==0) return true;


 if (result==true)
   {
    reset_count();
   }


 return result;

}


void hk_reportsection::reset_count(void)
{
        clear_countingfields();
	vector<hk_reportdata*>::iterator vit=p_data.begin();
 	while (vit!=p_data.end())
 	 {
             (*vit)->reset_count();
		vit++;
	 }
   vector<hk_reportsection*>::iterator vs=find(p_report->sections()->begin(),p_report->sections()->end(),this);
   while (vs!=p_report->sections()->end())
   {
      vs++;
      if (vs!=p_report->sections()->end()) if(!(*vs)->unique())(*vs)->reset_count();
   }
}
void hk_reportsection::automatic_create_datafields(void)
{
    //automatic create datafields if wished
    int z=10;
   if (p_automatic_create_datas&&!p_already_automaticcreated_data&&p_data.size()==0)
   {
     list<hk_column*>* cols=p_report->datasource()->columns();
     if (cols!=NULL)
     {
        list<hk_column*>::iterator cit=cols->begin();
        while (cit!=cols->end())
        {
         hk_reportdata* dat=new_data();
         dat->set_x(z);
         z+=dat->width()+10;
         dat->set_columnname((*cit)->name());
         dat->set_data(p_default_columnvalue);
         cit++;
        }
     }
     p_already_automaticcreated_data=true;
   }
    //END automatic create datafields if wished

}
void hk_reportsection::actual_hk_string(void)
{
 hk_string   p_buffer;
#ifdef HK_DEBUG
hkdebug("hk_reportsection::actualhk_string");
#endif
    p_buffer="";
    automatic_create_datafields();
    vector<hk_reportdata*>::iterator vit=p_data.begin();
    if (p_countings.size()==0)create_countingfields();
    else count_countingfields();
         if (p_report->datasource()->max_rows()>0)
          while (vit!=p_data.end())
           {
             (*vit)->count();
               vit++;
           }

         bool u=unique();
         bool uni=(u&&new_uniquevalue());
         if ((!u)||(uni))  //=>not unique section or unique section to be printed
         {
            vector<hk_reportdata*>::iterator vit=p_data.begin();
            p_buffer+=replace(sectionbegin());
         while (vit!=p_data.end())
           {

              if (vit!=p_data.begin())
                p_buffer+=replace(betweendata());
            p_buffer+=(*vit)->actual_hk_string();
            if(uni)(*vit)->reset_count();
           vit++;

           }

         p_buffer+=replace(sectionend());
         p_sectionwasprinted=true;
         if (p_replacefunction!=NULL) p_buffer=p_replacefunction(this,p_buffer);
         if (p_print_subreport_before_data) print_subreport();
//         if (p_sectioncountfunction!=NULL) p_counts_as=p_sectioncountfunction(this);
         p_report->rowcount(counts_as());
         *(p_report->outputstream()) <<p_buffer;
         if (!p_print_subreport_before_data) print_subreport();
        }
        else p_sectionwasprinted=false;


}


void hk_reportsection::create_countingfields(void)
{
#ifdef HK_DEBUG
hkdebug("hk_reportsection::create_countingfields");
#endif

     list<hk_column*>* collist=p_report->datasource()->columns();
     if ((collist!=NULL) &&(p_countings.size()==0))
     {
      list<hk_column*>::iterator colit =collist->begin();
      while (colit!=collist->end())
      {

       struct_countnumbers c;
       strcpy(c.colname,(*colit)->name().c_str());
       c.sum.real=c.squaresum.real=c.min.real=c.max.real=c.value.real=0;

        if ((*colit)->fieldtype()==hk_column::integerfield
   			||(*colit)->fieldtype()==hk_column::auto_incfield)
         {
           hk_string s=(*colit)->asstring();
   	   int r=atoi(s.c_str());
   	   c.sum.integer+=r;
   	   c.squaresum.integer+=r*r;
           c.min.integer=r;
   	   c.max.integer=r;
   	   c.value.integer=r;

         }
        else
         if((*colit)->fieldtype()==hk_column::floatingfield)
         {
           hk_string s=(*colit)->asstring();
   	   double r=strtod(s.c_str(),NULL);
   	   c.sum.real+=r;
   	   c.squaresum.real+=r*r;
   	   c.min.real=r;
   	   c.max.real=r;
   	   c.value.real=r;
         }


       colit++;
    }//end WHILE
  }//end IF p_countings.size()==0




}

void hk_reportsection::count_countingfields(void)
{
#ifdef HK_DEBUG
hkdebug("hk_reportsection::count_countingfields");
#endif
     list<hk_column*>* collist=p_report->datasource()->columns();
     list<hk_column*>::iterator colit =collist->begin();
     vector<struct_countnumbers>::iterator countit= p_countings.begin();
     while (colit!=collist->end()&&countit!=p_countings.end())
     {
     (*countit).count++;
    if ((*colit)->fieldtype()==hk_column::integerfield
   			||(*colit)->fieldtype()==hk_column::auto_incfield)

   {
        hk_string s=(*colit)->asstring();
   	int r=atoi(s.c_str());
   	(*countit).value.integer=r;
   	(*countit).sum.integer+=r;
   	(*countit).squaresum.integer+=r*r;
        if (r<(*countit).min.integer) (*countit).min.integer=r;
        if (r>(*countit).max.integer) (*countit).max.integer=r;

   }
   else if((*colit)->fieldtype()==hk_column::floatingfield)
  {
        hk_string s=(*colit)->asstring();
   	double r=strtod(s.c_str(),NULL);
   	(*countit).value.real=r;
   	(*countit).sum.real+=r;
   	(*countit).squaresum.real+=r*r;
        if (r<(*countit).min.real)(*countit).min.real=r;
        if (r>(*countit).max.real)(*countit).max.real=r;
   }




      colit++;
      countit++;
     }

}


void hk_reportsection::clear_countingfields(void)
{
 p_countings.erase(p_countings.begin(),p_countings.end());

}


void hk_reportsection::print_subreport(void)
{
 if (p_subreport!=NULL) p_subreport->execute();
}



void	hk_reportsection::set_unique(bool unique, const hk_string& fieldname, bool endsection)
{
   p_uniquecolumnname=fieldname;
   p_unique=unique;
   p_uniqueendsection=endsection;
}


void hk_reportsection::reset(void)
{
 clear_countingfields();


}


hk_string hk_reportsection::font(void)
{
 if (p_font.size()==0) return p_report->font();
 	else return p_font;
}
hk_string hk_reportsection::fontsize(void)
{
  if (p_fontsize.size()==0) return p_report->fontsize();
   return p_fontsize;
}

void	hk_reportsection::set_subreport(hk_report* subreport,bool before_data)
{
   p_subreport=subreport;
   p_print_subreport_before_data=before_data;
   if (subreport!=NULL)subreport->set_masterreport(p_report);
}

void  hk_reportsection::savedata(ofstream& s)
{
 start_mastertag(s,"SECTION");
// hk_reportbase::savedata(s);
 set_tagvalue(s,"UNIQUECOLUMNNAME",p_uniquecolumnname);
 set_tagvalue(s,"SECTIONBEGIN",p_sectionbegin);
 set_tagvalue(s,"SECTIONEND",p_sectionend);
 set_tagvalue(s,"BETWEENDATA",p_betweendata);
 set_tagvalue(s,"DEFAULTCOLUMNVALUE",p_default_columnvalue);
 set_tagvalue(s,"DEFAULTBEFORECOLUMN",p_default_beforecolumnvalue);
 set_tagvalue(s,"DEFAULTAFTERCOLUMN",p_default_aftercolumnvalue);
 set_tagvalue(s,"UNIQUEENDSECTION",p_uniqueendsection);
 set_tagvalue(s,"AUTOMATICCREATEDATA",p_automatic_create_datas);
 set_tagvalue(s,"NEWPAGEAFTERSECTION",p_newpageaftersection);
 set_tagvalue(s,"DATAS",(((p_data.size()==0)||p_already_automaticcreated_data) ?0:(unsigned long )p_data.size()));
hk_string recfunc="NONE";
 if (sectioncountfunction()==recount_postscript) recfunc="POSTSCRIPT";
set_tagvalue(s,"RECOUNTFUNCTION",recfunc);
hk_string configurefunc="NONE";
 if (p_default_dataconfigurefunction==configure_postscriptdata) configurefunc="POSTSCRIPT";
set_tagvalue(s,"DEFAULTDATACONFIGUREFUNCTION",configurefunc);

set_tagvalue(s,"SUBREPORT",(p_subreport==NULL ?"" : p_subreport->reportname()));

 if ((p_data.size()>0)&&!p_already_automaticcreated_data)
 {
 start_mastertag(s,"DATASECTION");
    vector<hk_reportdata*>::iterator it= p_data.begin();
    while (it!=p_data.end())
    {
      (*it)->savedata(s);
      it++;
    }
 end_mastertag(s,"DATASECTION");

 }


 end_mastertag(s,"SECTION");

}


void  hk_reportsection::loaddata(const hk_string& definition)
{
// hk_reportbase::loaddata(definition);
 get_tagvalue(definition,"UNIQUECOLUMNNAME",p_uniquecolumnname);
 get_tagvalue(definition,"SECTIONBEGIN",p_sectionbegin);
 get_tagvalue(definition,"SECTIONEND",p_sectionend);
 get_tagvalue(definition,"BETWEENDATA",p_betweendata);
 get_tagvalue(definition,"DEFAULTCOLUMNVALUE",p_default_columnvalue);
 get_tagvalue(definition,"DEFAULTBEFORECOLUMN",p_default_beforecolumnvalue);
 get_tagvalue(definition,"DEFAULTAFTERCOLUMN",p_default_aftercolumnvalue);
 get_tagvalue(definition,"UNIQUEENDSECTION",p_uniqueendsection);
 get_tagvalue(definition,"AUTOMATICCREATEDATA",p_automatic_create_datas);
 get_tagvalue(definition,"NEWPAGEAFTERSECTION",p_newpageaftersection);
hk_string recfunc;
 get_tagvalue(definition,"RECOUNTFUNCTION",recfunc);
 if ( recfunc=="POSTSCRIPT")
 {
 set_sectioncountfunction(&recount_postscript);
 }
 hk_string configurefunc;
 get_tagvalue(definition,"DEFAULTDATACONFIGUREFUNCTION",configurefunc);
 if  (configurefunc=="POSTSCRIPT") p_default_dataconfigurefunction=&configure_postscriptdata;

 unsigned long datas;
 get_tagvalue(definition,"DATAS",datas);
 hk_string datasection;
 get_tagvalue(definition,"DATASECTION",datasection);
 hk_string subreport;
get_tagvalue(definition,"SUBREPORT",subreport);
  if ((subreport.size()>0)&&(p_report->datasource()!=NULL))
    {
	if (p_automatic_created_datasource)
	{
	 delete p_subreportdatasource;
	 delete p_subreport;
	}
	p_automatic_created_datasource=true;

	p_subreportdatasource=p_report->datasource()->database()->new_resultquery();
        p_subreportdatasource->set_depending_on(p_report->datasource());
	set_subreport(new hk_report());
	p_subreport->set_datasource(p_subreportdatasource);
	p_subreport->load_report(subreport);
        get_tagvalue(definition,"DEPENDINGFIELDS",subreport);
    }
unsigned long i=1;
       while (i<=datas)
       {
        hk_reportdata* data=new_data();
        hk_string s;
        get_tagvalue(datasection,"DATA",s,i);
        data->loaddata(s);
        i++;
       }

}	

unsigned long hk_reportsection::counts_as(void)
{
   if (p_sectioncountfunction!=NULL)
     set_counts_as(p_sectioncountfunction(this));
   return (hk_dsdatavisible::counts_as());
}

hk_string hk_reportsection::replace(const hk_string& where)
{
   return where;
}

void hk_reportsection::set_datasource(hk_datasource* d)
{
  hk_dsdatavisible::set_datasource(d);
  vector<hk_reportdata*>::iterator it=p_data.begin();
  while (it!=p_data.end())
  {
    (*it)->set_datasource(d);
    it++;
  }
}
