// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.5 $
#include "hk_reportutils.h"
//****************************************************
//*                 HTML Stuff                       *
//****************************************************

hk_reporthtml::hk_reporthtml(void):hk_report()
{
   p_columnbefore="";
   set_recodefunction(&recode_html);
   p_withheader=true;
   p_pagehead="<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">\n";
   p_head="<meta http-equiv=\"Content-Type\" content=\"text/html;charset=iso-8859-1\">\n";

   p_beforetablesection=new_section();
   p_tableheadersection=new_section();
   p_datasection=new_section();
   p_tableendsection=new_section();
   p_pageheaddata=page_head()->new_data();
   p_beforetabledata=p_beforetablesection->new_data();
   p_aftertabledata=p_tableendsection->new_data();
   set_fileextension(".html");

   configure_page();
   configure_table();


}


hk_reporthtml::~hk_reporthtml(void)
{

}

void hk_reporthtml::configure_page(void)
{
   hk_string buffer=p_pagehead+"\n<HTML>\n <HEAD>\n";
   page_head()->set_sectionbegin(buffer);
   buffer="   ";
   buffer+=p_head;
   if (p_title.size()>0)
      {
         buffer+="   <TITLE>";
   	 buffer+=p_title+"</TITLE>\n";

      }
   if (p_author.size()>0)
      {
         buffer+="   <meta name=\"author\" content=\"";
   	 buffer+=p_author+"\">\n";

      }

   p_pageheaddata->set_data(recode_html(buffer));
   page_head()->set_sectionend("\n </HEAD>\n <BODY>\n");
   page_foot()->set_sectionend(" </BODY>\n</HTML>\n");
}


void hk_reporthtml::configure_table(void)
{
   hk_string buffer;
   hk_string trtag="   <TR ";
   hk_string trendtag="</TR>\n";
   trtag+=p_trtag+">";

   p_beforetablesection->set_unique(true,p_groupcolumn);
   p_beforetablesection->set_automatic_create_data(false);
   set_tabletag(" WIDTH=\"600\" BORDER=1 CELLSPACING=1");

   p_tableheadersection->set_unique(true,p_groupcolumn);
   if (p_withheader)
     {
       buffer="<TH ";
       buffer+=p_thtag+">%FIELDNAME%</TH>";
       p_tableheadersection->set_sectionbegin(trtag);
       p_tableheadersection->set_sectionend(trendtag);


     }
   else //(not withheader
     {
      buffer="";
     }
   p_tableheadersection->set_default_columnvalue(buffer);

   buffer="<TD ";
   buffer+=p_tdtag+">";
   p_datasection->set_default_beforecolumnvalue(buffer);
   p_datasection->set_default_aftercolumnvalue("</TD>");
   p_datasection->set_default_columnvalue("%VALUE%");
   p_datasection->set_sectionbegin(trtag);
   p_datasection->set_sectionend(trendtag);


   p_tableendsection->set_unique(true,p_groupcolumn,true);
   p_tableendsection->set_automatic_create_data(false);
   p_tableendsection->set_sectionbegin("  </TABLE>\n");
   p_tableendsection->set_new_page_after_section(p_multiplefiles);

   buffer="";
   if (p_aftervalue.size()>0)buffer=p_aftervalue;
   if (p_columnafter.size()>0)buffer+="%VALUE%";

   p_aftertabledata->set_data(buffer);

   buffer="\n";
   if (p_columnafter.size()>0)buffer=p_aftervalue;
   p_aftertabledata->set_data(buffer);
   p_aftertabledata->set_columnname(p_columnafter);
   buffer="\n";
   if (p_columnbefore.size()>0)buffer=p_beforevalue;
   p_beforetabledata->set_data(buffer);
   p_beforetabledata->set_columnname(p_columnbefore);


}

void hk_reporthtml::set_tabletag(const hk_string& t)
{
	p_tabletag=t;
	hk_string buffer;
        buffer="  <TABLE ";
        buffer+=p_tabletag+">\n";
        p_beforetablesection->set_sectionend(buffer);

}


void	hk_reporthtml::set_beforetable(const hk_string& value="%VALUE%",const hk_string& columnname)
{
   p_columnbefore=columnname;
   p_beforevalue=recode_html(value);
   configure_table();
}

void	hk_reporthtml::set_aftertable(const hk_string& value="%VALUE%",const hk_string& columnname)
{
   p_columnafter=columnname;
   p_aftervalue=recode_html(value);
   configure_table();
}


void hk_reporthtml::set_multiplefiles(bool m)
{
 hk_report::set_multiplefiles(m);
 configure_table();
}



void	hk_reporthtml::set_trtag(const hk_string& t)
{
   p_trtag=t;
   configure_table();
}


void	hk_reporthtml::set_thtag(const hk_string& t)
{
   p_thtag=t;
   configure_table();
}


void	hk_reporthtml::set_tdtag(const hk_string& t)
{
   p_tdtag=t;
   configure_table();
}



void	hk_reporthtml::set_beforehtmltag(const hk_string& b)
{
   p_pagehead=b;
   configure_page();
}



void	hk_reporthtml::set_betweenheadtags(const hk_string& b,const hk_string& colname)
{
   p_head=b;
   p_pageheaddata->set_columnname(colname);
   configure_page();
}

void	hk_reporthtml::set_title(const hk_string& t)
{
   p_title=t;
   configure_page();
}

void	hk_reporthtml::set_author(const hk_string& a)
{
   p_author=a;
   configure_page();
}


void	hk_reporthtml::set_groupcolumn(const hk_string& c)
{
   p_groupcolumn=c;
   configure_page();
}







hk_string  recode_html(const hk_string& where)
{
 hk_string p_where;
p_where=where;


hk_string benannt[]=
{
  "&nbsp;","&iexcl;","&cent;","&pound;","&curren;","&yen;",
  "&brvbar;","&sect;","&uml;","&copy;","&ordf;","&laquo;","&not;","&shy;",
  "&reg;","&macr;","&deg;","&plusmn;","&sup2;","&sup3;","&acute;","&micro;",
  "&para;","&middot;","&cedil;","&sup1;","&ordm;","&raquo;","&frac14;","&frac12;",
  "&frac34;","&iquest;","&Agrave;","&Aacute;","&Acirc;","&Atilde;","&Auml;","&Aring;",
  "&AElig;","&Ccedil;","&Egrave;","&Eacute;","&Ecirc;","&Euml;","&Igrave;","&Iacute;",
  "&Icirc;","&Iuml;","&ETH;","&Ntilde;","&Ograve;","&Oacute;","&Ocirc;","&Otilde;",
  "&Ouml;","&times;","&Oslash;","&Ugrave;","&Uacute;","&Ucirc;","&Uuml;","&Yacute;",
  "&THORN;","&szlig;","&agrave;","&aacute;","&acirc;",
  "&atilde;","&auml;","&aring;","&aelig;","&ccedil;","&egrave;","&eacute;","&ecirc;",
  "&euml;","&igrave;","&iacute;","&icirc;","&iuml;","&eth;","&ntilde;","&ograve;",
  "&oacute;","&ocirc;","&otilde;","&ouml;","&divide;","&oslash;","&ugrave;","&uacute;",
  "&ucirc;","&uuml;","&yacute;","&thorn;","&yuml;"

} ;


char* l= new char[2];
   l[1]=0;
if (p_where.size()==0)p_where="&nbsp;";
else
   for (int k=160;k<256;k++)
     {
      l[0]=k;
      p_where=replace_all(l,p_where,benannt[k-160]);
     }

 delete[] l;
return p_where;

}

//****************************************************
//*             POSTSCRIPT Stuff                     *
//****************************************************
hk_string  recode_postscript(const hk_string& where)
{
 hk_string p_where;
p_where=where;


char* m= new char[60];
char* l= new char[2];
   l[1]=0;
   for (int k=160;k<256;k++)
     {
      sprintf(m,"%#o",k);
      m[0]='\\';
      l[0]=k;
      p_where=replace_all(l,p_where,m);
     }
 delete[] l;
 delete[] m;
 p_where=replace_all("(",p_where,"\\(");
 p_where=replace_all(")",p_where,"\\)");

return p_where;

}


unsigned long recount_postscript(hk_reportsection* s)
{
  unsigned long c=0;
  unsigned long res=0;
  vector<hk_reportdata*>* dlist=s->datalist();
  if (dlist!=NULL)
  {
     vector<hk_reportdata*>::iterator it=dlist->begin();
     while (it!=dlist->end())
     {
      c=(*it)->y()+(*it)->height();
      if (c>res) res=c;
      it++;
     }
  }
 return res;
}

void   configure_postscriptdata(hk_reportdata* d)
{
  if (d==NULL) return;
  hk_string res="%XPOS% zmm %YPOS% zmm %WIDTH% zmm %HEIGHT% zmm (%ALIGN%) %FONTSIZE%  set_variables\n(";
 d->set_beforedata(res);
 if (d->wordbreak()) res=") /%FONT% BreakIntoLines\n";
 else res=") /%FONT% set_all\n" ;
 if (d->topline())res+="paint_top\n";
 if (d->bottomline())res+="paint_bottom\n";
 if (d->leftline())res+="paint_left\n";
 if (d->rightline())res+="paint_right\n";
 if (d->diagonalluro())res+="paint_diagonal_luro\n";
 if (d->diagonalloru())res+="paint_diagonal_loru\n";
 d->set_afterdata(res);
 d->set_height(atoi(d->fontsize().c_str())*254/72);
}


//****************************************************
//*             CVS Stuff                            *
//****************************************************

hk_reportcvs::hk_reportcvs(void):hk_report()
{
   p_datasection=new_section();
   p_footsection=new_section();
   p_withheader=true;
   p_delimiter="\"";
   p_between=" , ";
   configure_page();
}


hk_reportcvs::~hk_reportcvs(void)
{

}

void hk_reportcvs::set_groupcolumn(const hk_string& c)
{
    p_groupcolumn=c;
    p_footsection->set_unique(true,p_groupcolumn,true);
}

void hk_reportcvs::set_multiplefiles(bool m)
{
 hk_report::set_multiplefiles(m);
 p_footsection->set_new_page_after_section(m);
}

void	hk_reportcvs::set_dataformat(const hk_string& delimiter,const hk_string& between)
{
  p_delimiter=delimiter;
  p_between=between;
  configure_page();

}

void hk_reportcvs::set_withheader(bool with)
{

  p_withheader=with;
  configure_page();

}


void hk_reportcvs::configure_page(void)
{
    if (p_withheader)
      {

    		hk_string h=p_delimiter+"%FIELDNAME%";
    		h+=p_delimiter;
    		page_head()->set_default_columnvalue(h);
    		page_head()->set_betweendata(p_between);
    		page_head()->set_sectionend("\n");
    		page_head()->set_automatic_create_data(true);
      }
    else
    {
    		page_head()->set_default_columnvalue("");
    		page_head()->set_betweendata("");
    		page_head()->set_sectionend("");
    		page_head()->set_automatic_create_data(false);
    }

    hk_string h=p_delimiter+"%VALUE%";
    h+=p_delimiter;
    p_datasection->set_default_columnvalue(h);
    p_datasection->set_betweendata(p_between);
    p_datasection->set_sectionend("\n");
    p_datasection->set_automatic_create_data(true);
    p_footsection->set_unique(true, p_groupcolumn,true);
    p_footsection->set_automatic_create_data(false);

}


void set_cvs(hk_report* e,bool with_header,const hk_string& col_delimiter, const hk_string& betweendata)
{
    if (e==NULL)return;
    hk_string delimiter=col_delimiter;
    hk_string between=betweendata;
    if (with_header)
      {

    		hk_reportsection* header=e->new_section();
    		hk_string h=delimiter+"%FIELDNAME%";
    		h+=delimiter;
    		header->set_default_columnvalue(h);
    		header->set_betweendata(between);
    		header->set_sectionend("\n");
    		header->set_unique();

      }
    hk_reportsection* section=e->new_section();
    hk_string h=delimiter+"%VALUE%";
    h+=delimiter;
    section->set_default_columnvalue(h);
    section->set_betweendata(between);
    section->set_sectionend("\n");


}

