// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_mysqlclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#include <hk_mysqlcolumn.h>
#include <hk_mysqldatasource.h>
hk_mysqlcolumn::hk_mysqlcolumn(hk_mysqldatasource* ds, const hk_string& tTRUE,const hk_string& tFALSE) :hk_column(ds,tTRUE,tFALSE)
{
#ifdef HK_DEBUG
hkdebug("mysqlcolumn::constructor");
//wanna_debug(true);
#endif
  	p_mysqldatasource=ds;
        p_asstring=NULL;


}
hk_mysqlcolumn::~hk_mysqlcolumn(void)
{
#ifdef HK_DEBUG
hkdebug("mysqlcolumn::destructor");
#endif
   	if (p_asstring!=NULL)
  	{
  	 delete[] p_asstring;
  	 p_asstring=NULL;
  	}

}

unsigned int hk_mysqlcolumn::fieldnr()
{
	return p_fieldnr;
}


void hk_mysqlcolumn::fieldnr(unsigned int f)
{
   	p_fieldnr=f;
}


/*hk_string hk_mysqlcolumn::driver_specific_asstring()
{
#ifdef HK_DEBUG
hkdebug("hk_mysqlcolumn::driver_specific_asstring");
#endif 
      return driver_specific_asstring_at(p_mysqldatasource->row_position());
}
*/


hk_string	hk_mysqlcolumn::driver_specific_asstring_at(unsigned long a)
{
#ifdef HK_DEBUG
hkdebug("hk_mysqlcolumn::driver_specific_asstring_at",(int)a);
#endif 
  	if (p_mysqldatasource==NULL) return NULL;
  	if ((p_mysqldatasource->data()==NULL)||(p_mysqldatasource->max_rows()==0)
  	||(a>=p_mysqldatasource->max_rows())) return "";


  	vector<struct_raw_data*>* datalist=p_mysqldatasource->data();
  	struct_raw_data*  data=&(*datalist)[a][p_fieldnr];


 // 	struct_raw_data*  data=p_mysqldatasource->raw_data_at(p_fieldnr,a);

  	if (p_asstring!=NULL)
  	{
  	 delete[] p_asstring;
  	 p_asstring=NULL;
  	}

  	p_asstring= new char[data->length+1];

	unsigned int tk;
	for ( tk=0; tk <data->length;tk++)
	  {
	      p_asstring[tk]= data->data[tk];
	  }
	 p_asstring[tk]=0;
  return p_asstring;

}

const char* hk_mysqlcolumn::driver_specific_transformed_asstring_at(unsigned long position)
{
  	if (p_mysqldatasource==NULL) return NULL;
  	if ((p_mysqldatasource->data()==NULL)
	    ||(p_mysqldatasource->max_rows()==0)
	    ||(position>=p_mysqldatasource->max_rows())) return "";
  	vector<struct_raw_data*>* datalist=p_mysqldatasource->data();
  	struct_raw_data*  data=&(*datalist)[position][p_fieldnr];
  	if (p_asstring!=NULL)
  	{
  	 delete[] p_asstring;
  	 p_asstring=NULL;
  	}

  	p_asstring= new char[2*data->length+1];
   	mysql_escape_string(p_asstring,data->data,data->length);

  return p_asstring;

}


bool hk_mysqlcolumn::driver_specific_asstring(const hk_string& s)
{
#ifdef HK_DEBUG
hkdebug("hk_mysqlcolumn::driver_specific_asstring(char*)");
#endif 
//	cout <<"setzenasstring: "<<s<<endl;
	unsigned long a = s.size();
 	if (p_driver_specific_data!=NULL) {
 				delete[] p_driver_specific_data;
 				p_driver_specific_data=NULL;
 			      }
 	if (p_original_new_data!=NULL) {
 				delete[] p_original_new_data;
 				p_original_new_data=NULL;
 			      }
 	  p_driver_specific_data= new char[2*a+1];
 	  p_driver_specific_data_size=mysql_escape_string(p_driver_specific_data,s.c_str(),a);
 	  p_original_new_data=new char[a+1];
 	  strcpy(p_original_new_data,s.c_str());
 	  p_original_new_data_size=a;

 	return true;
}

void hk_mysqlcolumn::driver_specific_asbool(bool b)
{
 if (b) set_asstring(p_true.c_str());
 else	set_asstring(p_false.c_str());
// cout <<"Setzen asstring: "<<asstring()<<" truewert: "<<p_true<<" falsewert "<<p_false<<endl;
}

bool hk_mysqlcolumn::driver_specific_asbool(void)
{
// cout <<"Lesenasstring: "<<asstring()<<" truewert: "<<p_true<<endl;
 return (asstring()==p_true);
}


bool hk_mysqlcolumn::driver_specific_asbool_at(unsigned long a)
{
 return (asstring_at(a)==p_true);
}

bool hk_mysqlcolumn::driver_specific_asblob(const char* b)
{
 	if (p_driver_specific_data!=NULL) {
 				delete[] p_driver_specific_data;
 				p_driver_specific_data=NULL;
 			      }
 	  p_driver_specific_data= new char[2*p_original_new_data_size+1];
 	  p_driver_specific_data_size=mysql_escape_string(p_driver_specific_data,b,p_original_new_data_size);
return true;
}

const struct_raw_data* hk_mysqlcolumn::driver_specific_asblob()
{
#ifdef HK_DEBUG
hkdebug("driver_specific_asblob");
#endif
 return driver_specific_asblob_at(p_mysqldatasource->row_position());
}

const struct_raw_data* hk_mysqlcolumn::driver_specific_asblob_at(unsigned long a)
{
#ifdef HK_DEBUG
hkdebug("driver_specific_asblob_at");
#endif
  	if (p_mysqldatasource==NULL) return NULL;
  	if ((p_mysqldatasource->max_rows()==0)||(a>=p_mysqldatasource->max_rows())) return NULL;
  	vector<struct_raw_data*>* datalist=p_mysqldatasource->data();
  	return &(*datalist)[a][p_fieldnr];

}
