// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_mysqlclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#ifndef HK_MYSQLCOLUMN
#define HK_MYSQLCOLUMN
//#include <hk_string>
#include <mysql.h>
#include <errmsg.h>
#include <hk_column.h>
class hk_mysqldatasource;


class hk_mysqlcolumn:public hk_column

{   friend class hk_mysqldatasource;
    friend class hk_mysqltable;
    public:
    unsigned int fieldnr(void);
    void 	 fieldnr(unsigned int f);
    protected:
    hk_mysqlcolumn(hk_mysqldatasource* ds, const hk_string& TRUE,const hk_string& FALSE);
    virtual ~hk_mysqlcolumn(void);
//    hk_string	driver_specific_asstring(void);
    bool	driver_specific_asstring(const hk_string& s);
    hk_string	driver_specific_asstring_at(unsigned long a);
    const char* driver_specific_transformed_asstring_at(unsigned long position);
    void	driver_specific_asbool(bool b);
    bool 	driver_specific_asbool(void);
    bool	driver_specific_asbool_at(unsigned long a);
virtual bool    driver_specific_asblob(const char* b);
virtual	const struct_raw_data* driver_specific_asblob(void);
virtual const struct_raw_data* driver_specific_asblob_at(unsigned long a);
    private:
    char*	p_asstring;

    hk_mysqldatasource*	p_mysqldatasource;

} ;


#endif  
