// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_mysqlclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#include <hk_mysqlconnection.h>
#include <hk_mysqldatabase.h>
#include <dlfcn.h>
#include "hk_drivermanager.h"

hk_mysqlconnection::hk_mysqlconnection(hk_drivermanager* c):hk_connection(c)
{
 p_SQL_Connection=NULL;

}


hk_mysqlconnection::~hk_mysqlconnection()
{
        driver_specific_disconnect();
}

bool  hk_mysqlconnection::driver_specific_connect()
{

  char* db=0;
  char* xunix_port=0;
	if (!p_connected)
	{
		p_SQL_Connection=mysql_init(p_SQL_Connection);
		//cout <<"MYSQL TCP PORT:" <<tcp_port()<<endl;
		p_connected=mysql_real_connect(p_SQL_Connection,host().c_str(),user().c_str(),password().c_str(),db,tcp_port(),xunix_port,0);
	}
        return p_connected;

}


MYSQL* hk_mysqlconnection::dbhandler()
{
 	return p_SQL_Connection;
}



bool hk_mysqlconnection::driver_specific_disconnect()

{
	if (p_connected)
	{
	 	mysql_close(p_SQL_Connection);
	 	p_connected=false;

	}
	return p_connected;


}


const vector<hk_string>* hk_mysqlconnection::driver_specific_dblist(void)
{
  MYSQL_RES* Res;
  MYSQL_ROW row;
  char *wild=NULL;
  unsigned int i;
  p_databaselist->erase(p_databaselist->begin(),p_databaselist->end());

	if (p_connected)
	{
	   Res=mysql_list_dbs(p_SQL_Connection,wild);
	   if (Res==NULL)return p_databaselist;
	   while ((row=mysql_fetch_row(Res)))
	   	{
	   	  for (i=0 ; i < mysql_num_fields(Res);i++)
	   	    {
	   	       p_databaselist->insert(p_databaselist->end(),(row[i]));
	   	    }
	   	}
	mysql_free_result(Res);
	}
	;
return p_databaselist;
}



hk_database* hk_mysqlconnection::driver_specific_new_database(void)
{
	hk_mysqldatabase* db;
	db = new hk_mysqldatabase(this);
	return db;
}


int hk_mysqlconnection::server_supports(void)
{
 return supports_autoinc+supports_sql+supports_boolfield;
}


int hk_mysqlconnection::server_needs(void)
{
return needs_host+needs_username+needs_password+needs_port;

}


hk_connection* create_connection(hk_drivermanager* cl)
{
 hk_connection* c=NULL;
 void	*handle;
  handle=dlopen("libmysqlclient.so",RTLD_LAZY+RTLD_GLOBAL);
  if (handle==NULL)  handle=dlopen("/usr/lib/mysql/libmysqlclient.so",RTLD_LAZY+RTLD_GLOBAL);

 if (handle!=NULL)
 {
    c= new hk_mysqlconnection(cl);
 }
 else
 {
  hk_class::show_warningmessage(hk_class::hk_translate("MYSQLCLIENT Library could not be loaded"));
 }
 return c;
}
