// ****************************************************************************
// copyright (c) 2000,2001 Horst Knorr <hk_classes@knorrnet.de>
// This file is part of the hk_mysqlclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#ifndef HK_MYSQLDATASOURCE
#define HK_MYSQLDATASOURCE
#include <mysql.h>
#include <hk_datasource.h>
#include <hk_mysqlcolumn.h>
#include <hk_column.h>
#include <list>
#include <vector>
#include <algorithm>

class hk_mysqldatabase;
class hk_presentation;

class hk_mysqldatasource:public hk_datasource
{ friend class hk_mysqldatabase;
	public:
	vector <struct_raw_data*>* data();
	enum_datasourcetypes type();
//	struct_raw_data* raw_data_at(unsigned long col,unsigned long row);
virtual void	dump_data(void);

	protected:
	hk_mysqldatasource(hk_mysqldatabase* d,hk_presentation* p);
virtual	~hk_mysqldatasource();

	bool driver_specific_enable(void);
	bool driver_specific_disable(void);
virtual	list<hk_column*>* driver_specific_columns(void);
virtual	bool driver_specific_goto_row(unsigned long r);
virtual	unsigned long driver_specific_max_rows(void);
virtual	bool driver_specific_create_columns(void);
virtual	bool driver_specific_update_data(void);
virtual	bool driver_specific_insert_data(void);
virtual	bool driver_specific_delete_data_at(unsigned long);
	hk_mysqldatabase* p_mysqldatabase;
virtual	hk_column* driver_specific_new_column(void);
	void delete_data(void);

	private:
	vector<struct_raw_data*> p_data;
	MYSQL_RES* p_result;
	MYSQL_ROW p_row;
	unsigned long *p_length;
	unsigned long p_rows;
	bool p_data_changed;
        long p_debug_counter;
        struct_raw_data p_d;
}
;

#endif 
